CCC   #################################################################
CCC                            SPheRIO Ver 4.00
CCC             Smoothed Particle hydrodynamical evolution of 
CCC                  Relativistic heavy-IOn collisions
CCC   #################################################################
CCC   nrevt... event ID, controlled by NeXus, xx.optns file
CCC   #################################################################
      SUBROUTINE spherio(nrevt,nfrzz)
      IMPLICIT NONE 
      include 'epos.incico'
      include 'epos.incsf'
      include 'spherio.inc'
      include 'spherio.io.inc'
      include 'spherio.quifz.inc'
      include 'spherio.hbt.inc'
	include 'spherio.hydro.inc'
      include 'spherio.debug.inc'
CCC   #################################################################
      INTEGER nrevt,Nfr,Nrs,ntsp,kk,nn  
      INTEGER nfrzz,nnffrr
      DOUBLE PRECISION tau
cxx      DOUBLE PRECISION tamxf
      CHARACTER evgflg*3 
      CHARACTER*50 version
      PARAMETER (version='Version 201010301548BR')
CCC   #################################################################
      save nnffrr
      save evgflg
CCC   #################################################################
      IF(nfrzz.le.0)THEN
CCC   The following info will be printed on the screen
CCC   ###################################################################
CCC   #                       SPHERIO 4.00                              #
CCC   #        Smoothed Particle hydrodynamical evolution of            #
CCC   #               Relativistic heavy-IOn collisions                 #
CCC   ###################################################################
      WRITE(*,*)('#',kk=1,63)
      WRITE(*,*)'#                       ',
     &          'SPHERIO 4.00',
     &          '                          #'
	WRITE(*,*)'#        ',
     &          'Smoothed Particle hydrodynamical evolution of',
     &          '        #'
      WRITE(*,*)'#               ',
     &          'Relativistic heavy-IOn collisions',
     &          '             #'
	WRITE(*,*)('#',kk=1,63)
      OPEN(11,FILE=fnztr(1:nfnztr),STATUS='UNKNOWN')
      WRITE(11,*)'SPheRIO starts ...'
      CLOSE(11)
      OPEN(11,FILE=fnztr(1:nfnztr),STATUS='UNKNOWN',ACCESS='APPEND')
      WRITE(11,*)('-',kk=1,63)
      WRITE(11,*)'Welcome to SPheRIO 4.00'
      WRITE(11,*)version
      WRITE(11,*)('-',kk=1,63)
	CLOSE(11)
	ENDIF
CCC   #################################################################
      OPEN(11,FILE=fnztr(1:nfnztr),STATUS='UNKNOWN',ACCESS='APPEND')
      WRITE(11,*)'nfrzz=',nfrzz
cxx      WRITE(*,*)'nfrzz=',nfrzz
	CLOSE(11)
      if(nfrzz.gt.0) goto 1029
	CALL setitrobmd()
	call seticomode()
      include 'spherio.set'
CCC   clean up the log files
      CALL setlog()
CCC   #################################################################
CCC   define seed
      CALL setseedspo()
CCC   #################################################################
CCC   define o parametro isphmode da condicao inicial
      CALL settautrans()
      CALL settrinimode()
      CALL setsphsplit()
CCC   #################################################################
CCC   emissao continua
CCC   #################################################################
      CALL set_flagce
      CALL set_flagxn
CCC   #################################################################
CCC   define temperatura de freeze-out e temperatura final
CCC   chemical freezeout parameters
CCC   necessary override according to debugging index
CCC   #################################################################
      CALL settempsph()
CCC   #################################################################
CCC   define o parametro \kappa da emissao continua
      CALL setkappa()
CCC   #################################################################
CCC   set 3D or 2D calculation
	CALL setdimension()
CCC   #################################################################
CCC   define o parametro irft
      CALL rfactorset()
CCC   #################################################################
CCC   reset temperature parameters according to bugflg option
      CALL seteosmode()
c      CALL pesotrials()
      CALL loadeos()
      CALL settempsphdenovo()
CCC   #################################################################
CCC   test the eos and phsjdg subroutine
      CALL phsjdgtrials()
      CALL eosphtrials()
      if (iepdbug1.eq.1)CALL epostrials()
      CALL rfactorprint()
CCC   #################################################################
CCC   modeprint
CCC   #################################################################
      CALL modeprint(tau,Nfr,Nrs)
CCC   #################################################################
      if (ireadfzo.eq.1) THEN
	CALL readfzo(nnffrr)
	Nfr=nnffrr
	GOTO 1029
      ENDIF
CCC   #################################################################
CCC   SPH particles IC configuration entry
      CALL config_switch(tau,nrevt)
CCC   #################################################################
CCC   check point to skip SPheRIO with nfrzz=-1
CCC   #################################################################
      if(nfrzz.lt.0) then
      WRITE(*,*)' === SPheRIO is skipped .... === '
      OPEN(11,FILE=fnztr(1:nfnztr),STATUS='UNKNOWN',ACCESS='APPEND')
      WRITE(11,*)'SPheRIO is skipped ...'
      CLOSE(11)
      RETURN
	endif
CCC   #################################################################
CCC   Solving hydrodyamics
CCC   #################################################################
cxx      tamxf=tau+dtau*dble(ntspx)  !! [fm]
	ntsp=0
	CALL setflagfp(ntsp,tau)
	CALL lssf0(ntsp,tau,Nfr,Nrs)
	CALL fldobsrv()
      DO 1024 ntsp=0, ntspx
         if (iepdbug2.eq.1)CALL TransferTauNsp(tau,nsp(1),stot,btot)
         CALL solvediff(ntsp,tau)
	   if (ntsp.eq.0.and.stot.eq.0.d0) then
	        call setnex_null()
              return
	   endif
         if (iepdbug3.eq.1)CALL eposhydrotable(ntsp,tau)
	   CALL trobsrv_ctrl(ntsp,tau)
cxx         if(ntsp.ge.2) CALL lssf(ntsp,tau,Nfr,Nrs)
         CALL lssf(ntsp,tau,Nfr,Nrs)
CCC   #################################################################
         IF(ntsp.ge.2.and.Nrs.eq.0) GOTO 1027
 54      FORMAT(a,f5.2,a,i5,a,i5,a,i5)
 1024 CONTINUE
 1027 CONTINUE
      OPEN(11,FILE=fnztr(1:nfnztr),STATUS='UNKNOWN',ACCESS='APPEND')
      WRITE(11,*)  'All freeze-out (^^)/~ '
      CLOSE(11)
CCC   #################################################################
	nnffrr=Nfr
	CALL fldobsrv_fin(nnffrr)
      if(evgflg.eq.'ON') call setevg(nnffrr)
      if (imakefzo.eq.1) CALL makefzo(nnffrr)
cxx      if(evgflg.eq.'ON') call setevg_ic
      if(imhbt.ge.1) call evghbt(nnffrr)
 1029 continue
      if(ifz.ne.1) RETURN
      if(imhbt.le.1) call evgen_nogo(nnffrr,nfrzz)
	if(ixell.eq.1) call xellwrite(nfrzz)
cxx      if(imhbt.le.1) call evgen_ic
      RETURN
      STOP 234
      END
CCC   #################################################################
CCC   #################################################################
CCC   #################################################################
CCC   #################################################################
CCC   #################################################################

