CCC   #################################################################
CCC   phasedig.f for SPheRIO \(^^) 
CCC   for finding phase_diagram
CCC   #################################################################
CCC   last updated 05072006
CCC   esq, esr are expend from (1:4,0:2) --> (1:5,0:2) to adopt the 
CCC   modification in geteos(), while the extra data is not used here
CCC   last updated 11102001
CCC   #################################################################
      SUBROUTINE diagram() 

      IMPLICIT NONE 
      include 'spherio.const.inc'
	include 'spherio.fnames.inc'
	include 'epos.incsf'
      DOUBLE PRECISION BAGCNST
      DOUBLE PRECISION ub,Tm,Tmx,rgms,rtflsp2
      INTEGER ng,nb,nq,ns,itm
      INTEGER phsflg
      DOUBLE PRECISION prdiff
      DOUBLE PRECISION ub1,ub2
      DOUBLE PRECISION Pex,R0
      DOUBLE PRECISION esr(1:5,0:2),esq(1:5,0:2) 
      DOUBLE PRECISION Tmstepin 
      CHARACTER filename1*108,filename2*108 
      COMMON/prtclms/ rgms(1000)
      COMMON/quantum/ ng(1000),nb(1000),nq(1000),ns(1000)
      COMMON/BAGCNST/BAGCNST
      COMMON/HARDCORE/R0
      COMMON/TEMPERA/Tm
      COMMON/CHEMPOT/ub
      COMMON/PEX/Pex
      EXTERNAL prdiff

      filename1= fneos(1:nfneos)//eosdatapath1//mixphf1
      filename2= fneos(1:nfneos)//eosdatapath1//mixphf2

CCC   ########################
CCC   //////////////////////////////////////////////////////////////
ccc   finding the first point...
      Tmx= 0.160d+00            !! initial tryal value for 1st point
      ub1= 0.000d+00            !! initial tryal value for 1st point
      ub2= 0.250d+00            !! initial tryal value for 1st point
      Tmstepin= 1.d-04
 122  continue 
      Tm= Tmx 
      ub= rtflsp2(prdiff,ub1,ub2,1.00d-02)
      if(ub.gt.8.88d+88) then
         Tmx=Tmx-Tmstepin 
         goto 122
      end if
      if(ub.gt.1.00d-08) then   !! we regards ub=0 in the below: 
         Tmx=Tmx+Tmstepin 
         Tmstepin= Tmstepin/10d+00 
         goto 122 
      end if 
CCC   //////////////////////////////////////////////////////////////
ccc   =======================================================
      phsflg=0 
      call geteos(Tm,ub,phsflg,esr)
      open(10,file=filename1,status='unknown')
      write(10,'(5d16.8)') Tm,ub,esr(1,0),esr(2,0),zero 
      close(10)
ccc   =======================================================
      phsflg=2 
      call geteos(Tm,ub,phsflg,esq) 
      open(11,file=filename2,status='unknown')
      write(11,'(5d16.8)') Tm,ub,esq(1,0),esq(2,0),zero 
      close(11)
ccc   =======================================================
CCC   //////////////////////////////////////////////////////////////
      do 123 itm=99,1,-1
         ub1=ub*(+0.95d+00) !! negative direction 
         ub2=ub*(+2.50d+00) !! negative direction 
 129     continue
         Tm= Tmx/100d+00 *dble(itm)
         ub= rtflsp2(prdiff,ub1,ub2,1.00d-02)
         if(ub.gt.8.88d+88) then 
            ub2=ub2*1.500d+00
            if(abs(ub2).gt.2.5d+00) stop 'solution not found'  
            goto 129 
         end if
ccc   ============================================================ 
         phsflg=0 
         call geteos(Tm,ub,phsflg,esr)
         open(10,file=filename1,status='unknown',access='append')
         write(10,'(5d16.8)') Tm,ub,esr(1,0),esr(2,0),esr(3,0)
         close(10)         
ccc   =============================================================
         phsflg=2 
         call geteos(Tm,ub,phsflg,esq) 
         open(10,file=filename2,status='unknown',access='append')
         write(10,'(5d16.8)') Tm,ub,esq(1,0),esq(2,0),esq(3,0) 
         close(10)
ccc   ============================================================= 
 123  continue
CCC   ///////////////////////////////////////////////////////////////
      RETURN
      STOP 234
      END



C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@



CCC   #################################################################
CCC   findpex.f for SPheRIO \(^^) 
CCC   for finding Pex, pressur correctwd by the excluded volume effect
CCC   last updated at                     Mon Sep 10 16:41:56 BRT 2001
CCC   #################################################################
      SUBROUTINE findpex(Tm,ub,phsflg)
      
      IMPLICIT NONE 
      DOUBLE PRECISION zero,uni,half,two,three,four,six,epsilon
      DOUBLE PRECISION pi,pimass,hbarc
      PARAMETER(zero=0.0000d+00,uni=1.0000d+00,half=0.5000d+00) 
      PARAMETER(two=2.000d+00,four=4.000d+00,epsilon=1.000d-08) 
      PARAMETER(three=3.000d+00,six=6.000d+00)
      PARAMETER(pi=3.141592654d+00) 
      PARAMETER(pimass=0.140d+00, hbarc= 0.197327053d+00) !![GeV*fm] 
      DOUBLE PRECISION Tm,ub,Pex,Pr,rtnewt
      DOUBLE PRECISION Tmtr,ubtr 
      INTEGER phsflg 
      EXTERNAL pexx 
      COMMON/TEMPERA/Tmtr 
      COMMON/CHEMPOT/ubtr 
      COMMON/PEX/Pex
      Tmtr=Tm
      ubtr=ub       
      call pideal(Tm,ub,Pr,phsflg)   !! RG RG RG RG RG 
      if(Pr.eq.zero) then 
         Pex=zero 
         return
      end if
ccc   == rtnewt is a routine in Numerical recipes in Fortran 77 == 
      Pex= rtnewt(pexx,Pr,Pr*1.00d-03)
      RETURN
CCC   ///////////////////////////////////////////////////////////
      STOP 234
      END




CCC   #################################################################
CCC   entopy.f for SPheRIO \(^^) 
CCC   edbary revised, de^{ex}/dT, de^{ex}/duB and so on. 
CCC   (excuded volume effect corrected is included for RG) 
CCC   last updated 05072006
CCC   include 'spherio.const.inc' and include 'spherio.esqr.inc'
CCC   the evaluation of esqr(5,0) is not implemented here 
CCC   cuz this subroutine is to be obsoleted
CCC
CCC   last updated 11242001
CCC   #################################################################
      SUBROUTINE geteos(Tm,ub,phsflg,esqr) 
      
      IMPLICIT NONE 
      include 'spherio.const.inc'
      include 'spherio.esqr.inc'
	include 'spherio.debug.inc'
      include 'epos.incsf'
      DOUBLE PRECISION Tm,ub,ee,bb,qq,ss
      DOUBLE PRECISION pp,dp,uu
      DOUBLE PRECISION rgms,Thermf,BAGCNST
      DOUBLE PRECISION pered(500),peren(500),perbd(500)
      DOUBLE PRECISION perpr(500),pnumd(500)
      DOUBLE PRECISION energyd,entropy,baryond,pressur
      DOUBLE PRECISION crrctn1,crrctn2,crrctn3
      DOUBLE PRECISION Dence,up0,up1,up2,up3,up4,factor,jac21,jac22
      DOUBLE PRECISION I01(500),J01,up01,I02(500),J02,up02
      DOUBLE PRECISION I11(500),J11,up11,I12(500),J12,up12
      DOUBLE PRECISION I21(500),up21,I22(500),up22
      DOUBLE PRECISION I31(500),J31,up31,I32(500),J32,up32

      DOUBLE PRECISION Pex,R0,V0,dPexdt,dPexdu,pexcl   
      INTEGER ng,nb,nq,ns,Id,ic
      INTEGER phsflg,idst,idfn 
      COMMON/prtclms/ rgms(1000)
      COMMON/quantum/ ng(1000),nb(1000),nq(1000),ns(1000) 
      COMMON/BAGCNST/BAGCNST
      COMMON/HARDCORE/R0
      COMMON/PEX/Pex

      if(Tm.le.zero) goto 779
      pexcl= zero 
      if(phsflg.eq.0) call findpex(Tm,ub,phsflg) 
CCC   ////////////////////////////////////////////////////
      if(phsflg.eq.0) then      !! resonance gas 
         idst=1
         idfn=411 
      else if(phsflg.eq.2) then !! quark gluon plasma 
         idst=450
         idfn=456 
      end if
CCC   ////////////////////////////////////////////////////
      crrctn1= zero             !! correction factor 
      energyd= zero             !! energy  density
      entropy= zero             !! entropy density
      baryond= zero             !! baryon number density 
      pressur= zero             !! pressure 
      do 420 Id=idst,idfn 
         if(ng(Id).eq.0) goto 420
CCC   ##############################################################
         bb= dble(nb(Id))
         qq= dble(nq(Id))
         ss= dble(ns(Id))
         if(Id.gt.450) bb=bb/3.00d+00 
         if(Id.gt.450) qq=qq/3.00d+00 
	 uu= bb *ub
CCC   /////////////////////////////////////////
ccc   excluded volume effect: 
         if(phsflg.eq.0.and.Id.ge.150) then 
            V0= 4.d+00*pi*R0*R0*R0/3.d+00
         else
            V0= zero 
         end if
         uu= uu-V0*Pex          !! uu tildear 
CCC   /////////////////////////////////////////
         ic=0
         dp= rgms(Id)/150.d+00
         if(dp.lt.epsilon) dp=1.d-03
         pp= dp 
         pered(Id)= zero 
         peren(Id)= zero
         perbd(Id)= zero 
         perpr(Id)= zero 
         pnumd(Id)= zero 
         I01(Id)= zero
         I02(Id)= zero
         I31(Id)= zero
         I32(Id)= zero
         I11(Id)= zero 
         I12(Id)= zero
         I21(Id)= zero 
         I22(Id)= zero 
 520     continue
         ee= sqrt(pp*pp+rgms(Id)*rgms(Id))
CCC   -----------------------------------------------
CCC   Simpson's foruula(with automatic termination) 
         if(ic.eq.0) then 
            factor=uni 
         else if(mod(ic,2).eq.1) then 
            factor=four
         else if(mod(ic,2).eq.0) then
            factor=two 
         end if
CCC   -----------------------------------------------
         if((ee-uu)/Tm.gt.+299.d+00) then 
            Thermf= exp(+299.d+00) 
         else if((ee-uu)/Tm.lt.-299.d+00) then
            Thermf= exp(-299.d+00) 
         else 
            Thermf= exp((ee-uu)/Tm) 
         end if
CCC   -----------------------------------------------
CCC   ///////////////////////////////////////////////////////////
         if(Id.lt.150.or.Id.eq.450) then 
                                !! == Boson  (Mesons) ==             
            Dence=  uni/(Thermf-uni)
            up0=   ee *Dence 
            up1= -log(uni-uni/Thermf)+(ee-uu)/Tm/(Thermf-uni)
            up2=   Dence 
            up3=   bb *Dence 
            up4=   -Tm *log(uni-uni/Thermf)
            up01= up0 *Dence *(ee-uu)/(Tm*Tm) *Thermf 
            up02= up0 *Dence *(Thermf/Tm)
            up11= ((ee-uu)/Tm)**2 *(Thermf/Tm)* Dence**2 
            up12=  (ee-uu)/Tm     *(Thermf/Tm)* Dence**2 
            up21=  (ee-uu)/Tm     *(Thermf/Tm)* Dence**2 
            up22=                  (Thermf/Tm)* Dence**2  
            up31= up3 *Dence *(ee-uu)/(Tm*Tm) *Thermf 
            up32= up3 *Dence *(Thermf/Tm)
CCC   ///////////////////////////////////////////////////////////
         else                   !! == Fermion(Baryons) == 
            Dence= uni/(Thermf+uni)
            up0= ee *Dence 
            up1= +log(uni+uni/Thermf)+(ee-uu)/Tm/(Thermf+uni)
            up2=  Dence 
            up3=  bb  *Dence 
            up4=  +Tm *log(uni+uni/Thermf)
            up01= up0 *Dence *(ee-uu)/(Tm*Tm) *Thermf
            up02= up0 *Dence *(Thermf/Tm)
            up11= ((ee-uu)/Tm)**2 *(Thermf/Tm)* Dence**2
            up12= ((ee-uu)/Tm)    *(Thermf/Tm)* Dence**2
            up21=  (ee-uu)/Tm     *(Thermf/Tm)* Dence**2
            up22=                  (Thermf/Tm)* Dence**2  
            up31= up3 *Dence *(ee-uu)/(Tm*Tm) *Thermf
            up32= up3 *Dence *(Thermf/Tm)
         end if
CCC   /////////////////////////////////////////////////////////// 
         up0=up0*pp*pp*dp*dble(ng(Id))/(two*pi*pi)*factor/three
         up1=up1*pp*pp*dp*dble(ng(Id))/(two*pi*pi)*factor/three
         up2=up2*pp*pp*dp*dble(ng(Id))/(two*pi*pi)*factor/three
         up3=up3*pp*pp*dp*dble(ng(Id))/(two*pi*pi)*factor/three
         up4=up4*pp*pp*dp*dble(ng(Id))/(two*pi*pi)*factor/three

         up01=up01*pp*pp*dp*dble(ng(Id))/(two*pi*pi)*factor/three
         up02=up02*pp*pp*dp*dble(ng(Id))/(two*pi*pi)*factor/three
         up11=up11*pp*pp*dp*dble(ng(Id))/(two*pi*pi)*factor/three
         up12=up12*pp*pp*dp*dble(ng(Id))/(two*pi*pi)*factor/three
         up21=up21*pp*pp*dp*dble(ng(Id))/(two*pi*pi)*factor/three
         up22=up22*pp*pp*dp*dble(ng(Id))/(two*pi*pi)*factor/three
         up31=up31*pp*pp*dp*dble(ng(Id))/(two*pi*pi)*factor/three
         up32=up32*pp*pp*dp*dble(ng(Id))/(two*pi*pi)*factor/three

         pered(Id)= pered(Id)+ up0 
         peren(Id)= peren(Id)+ up1
         pnumd(Id)= pnumd(Id)+ up2
         perbd(Id)= perbd(Id)+ up3
         perpr(Id)= perpr(Id)+ up4 

         I01(Id)=   I01(Id)  +up01 
         I02(Id)=   I02(Id)  +up02 
         I11(Id)=   I11(Id)  +up11
         I12(Id)=   I12(Id)  +up12
         I21(Id)=   I21(Id)  +up21
         I22(Id)=   I22(Id)  +up22
         I31(Id)=   I31(Id)  +up31 
         I32(Id)=   I32(Id)  +up32 
         
         if(peren(Id).gt.zero) then 
            if(up1/peren(Id).lt.1.d-08) then !! condition of converge
               pered(Id)=pered(Id)/(hbarc*hbarc*hbarc) !![GeV/fm^3]
               perpr(Id)=perpr(Id)/(hbarc*hbarc*hbarc) !![GeV/fm^3]
               peren(Id)=peren(Id)/(hbarc*hbarc*hbarc) !![1/fm^3] 
               pnumd(Id)=pnumd(Id)/(hbarc*hbarc*hbarc) !![1/fm^3] 
               perbd(Id)=perbd(Id)/(hbarc*hbarc*hbarc) !![1/fm^3]
ccc   ....     note that: u~ = uu-V0*Pex(Tm,uu)    .....
               I01(Id)=  I01(Id)/(hbarc*hbarc*hbarc) !! de/dT
               I02(Id)=  I02(Id)/(hbarc*hbarc*hbarc) !! de/du~
               I11(Id)=  I11(Id)/(hbarc*hbarc*hbarc) !! ds/dT  
               I12(Id)=  I12(Id)/(hbarc*hbarc*hbarc) !! ds/du~   
               I21(Id)=  I21(Id)/(hbarc*hbarc*hbarc) !! dnd/dT    
               I22(Id)=  I22(Id)/(hbarc*hbarc*hbarc) !! dnd/du~  
               I31(Id)=  I31(Id)/(hbarc*hbarc*hbarc) !! dnB/dT 
               I32(Id)=  I32(Id)/(hbarc*hbarc*hbarc) !! dnB/du~ 
               goto 418
            end if
         end if
	 ic=ic+1
         if(ic.gt.250.and.peren(Id).le.1.d-99) then 
            goto 420 
         end if
         pp=pp+dp
         goto 520  
 418     continue
         energyd= energyd+ pered(Id) 
         pressur= pressur+ perpr(Id) 
         entropy= entropy+ peren(Id)
         baryond= baryond+ perbd(Id)
         crrctn1= crrctn1+ V0* pnumd(Id) 
CCC   ##############################################################
 420  continue   
      crrctn1= uni+ crrctn1 
      
      energyd= energyd/crrctn1  !! excl.vol.corr.
      entropy= entropy/crrctn1  !! excl.vol.corr.
      baryond= baryond/crrctn1  !! excl.vol.corr.      
      pressur= pressur          !! no correction 
c     pressur= Pex (should be, for RG case) 
      if(phsflg.eq.0) pressur= Pex 
      dPexdt=  entropy
      dPexdu=  baryond

      J01= zero
      J02= zero
      J31= zero 
      J32= zero 
      J11= zero 
      J12= zero
      crrctn2= zero             !! correction factor 
      crrctn3= zero             !! correction factor 
CCC   #################################################################
      do 720 Id=idst,idfn
         if(ng(Id).eq.0) goto 720

         bb= dble(nb(Id))
         qq= dble(nq(Id))
         ss= dble(ns(Id))
         if(Id.gt.450) bb=bb/3.00d+00 
         if(Id.gt.450) qq=qq/3.00d+00 
CCC   /////////////////////////////////////////
ccc   excluded volume effect: 
         if(phsflg.eq.0.and.Id.ge.150) then 
            V0= 4.d+00*pi/3.d+00 *R0*R0*R0
         else
            V0= zero 
         end if
CCC   /////////////////////////////////////////
ccc   ========================================
         jac21=    -V0*dPexdt   !! du~/dT 
         jac22= bb -V0*dPexdu   !! du~/duB 
ccc   ========================================
         J01= J01+ I01(Id) +I02(Id)*jac21
         J02= J02+          I02(id)*jac22
         J11= J11+ I11(Id) +I12(Id)*jac21
         J12= J12+          I12(id)*jac22
         J31= J31+ I31(Id) +I32(Id)*jac21
         J32= J32+          I32(id)*jac22
         crrctn2= crrctn2+ V0*( I21(Id) +I22(Id)*jac21 )
         crrctn3= crrctn3+ V0*( I22(Id) *jac22  )
 720  continue
CCC   #################################################################
ccc   outputs: 
      if(phsflg.eq.2) energyd= energyd+BAGCNST
      esqr(1,0)= energyd                        !! e   :  energy  density 
      esqr(2,0)= entropy                        !! s   :  entropy density 
      esqr(3,0)= baryond                        !! n_B : baryon number density
      if(phsflg.eq.2) pressur= pressur-BAGCNST
      esqr(4,0)= pressur              !! P   : pressure 
      esqr(1,1)= J01/crrctn1-energyd/crrctn1*crrctn2 !! de^{ex}/dT 
      esqr(1,2)= J02/crrctn1-energyd/crrctn1*crrctn3 !! de^{ex}/duB 
      esqr(2,1)= J11/crrctn1-entropy/crrctn1*crrctn2 !! ds^{ex}/dT
      esqr(2,2)= J12/crrctn1-entropy/crrctn1*crrctn3 !! ds^{ex}/duB 
      esqr(3,1)= J31/crrctn1-baryond/crrctn1*crrctn2 !! dnB^{ex}/dT
      esqr(3,2)= J32/crrctn1-baryond/crrctn1*crrctn3 !! dnB^{ex}/duB 
CCC   for debug purpose only
      esqr(5,0)=zero
CCC   for debug purpose only
      RETURN
 779  OPEN(70,FILE=fneoe(1:nfneoe),access='append')
      WRITE(70,*) 'Tm<0 error in geteos.f'
      CLOSE(70)
      STOP ' error: Tm<0 error in geteos.f ' 
      END 



C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


CCC   #################################################################
CCC   gettmu.f for SPheRIO (^^)/ 
CCC   for solving inverse problem, get T and uB from density  
CCC   last updated at                     
CCC   #################################################################
      SUBROUTINE gettmu(given,gf,Tm,ub,phsflg,m2)

      IMPLICIT NONE 
      DOUBLE PRECISION zero,uni,half,two,three,four,six,epsilon
      DOUBLE PRECISION pi,pimass,hbarc
      PARAMETER(zero=0.0000d+00,uni=1.0000d+00,half=0.5000d+00) 
      PARAMETER(two=2.000d+00,four=4.000d+00,epsilon=1.000d-08) 
      PARAMETER(three=3.000d+00,six=6.000d+00)
      PARAMETER(pi=3.141592654d+00) 
      PARAMETER(pimass=0.14d+00, hbarc= 0.197327053d+00) !![GeV*fm] 
      DOUBLE PRECISION given(3),tolx,tolf
      INTEGER ndim 
      parameter(ndim=2) 
      DOUBLE PRECISION Tmin,ubin,solution(ndim),Tm,ub
      DOUBLE PRECISION Tmbf,ubbf
      INTEGER gf,m2            !!  gf=1-> e // gf=2-> s  
      INTEGER ntrial
      INTEGER phsflg
      
ccc   /////////////////////////////////////////////////////////////////////
      SAVE Tmbf,ubbf
      data ntrial/ 250/
      data tolx/1.d-12/         !! precision of T amd ub (in GeV). 
      data tolf/1.d-12/         !! precision of energy and nb density 
      Tmin=  0.20d+00            !! tryal in [GeV] [set a little bit high] 
      ubin= -0.20d+00            !! tryal in [GeV] 
ccc   /////////////////////////////////////////////////////////////////////
      if(m2.le.3) then 
         solution(1)= Tmin 
         solution(2)= ubin 
      else
         solution(1)= Tmbf
         solution(2)= ubbf
      end if
      call mnewtgetmu(ntrial,solution,ndim,tolx,tolf,given,gf,phsflg)
      Tm= solution(1)
      ub= solution(2) 
      if(Tm.ne.zero) then 
         Tmbf= Tm
         ubbf= ub 
      end if
      RETURN 
      STOP 234
      END 






CCC   #################################################################
CCC   exclv.f for SPheRIO \(^^) 
CCC   to find Pex(xx) for the exclued volume correction  
CCC   last updated at                     Mon Sep 10 16:41:56 BRT 2001
CCC   #################################################################
      SUBROUTINE pexx(xx,fn,df) 
      IMPLICIT NONE 
      DOUBLE PRECISION zero,uni,half,two,three,four,six,epsilon
      DOUBLE PRECISION pi,pimass,hbarc,R0,V0,Pex 
      PARAMETER(zero=0.0000d+00,uni=1.0000d+00,half=0.5000d+00) 
      PARAMETER(two=2.000d+00,four=4.000d+00,epsilon=1.000d-08) 
      PARAMETER(three=3.000d+00,six=6.000d+00)
      PARAMETER(pi=3.141592654d+00) 
      PARAMETER(pimass=0.14d+00, hbarc= 0.197327053d+00) !![GeV*fm] 
      DOUBLE PRECISION Tm,ub,ee,bb,qq,ss
      DOUBLE PRECISION pp,dp,uu,prss,Ps,prdd,Pd 
      DOUBLE PRECISION rgms,Thermf,BAGCNST
      DOUBLE PRECISION up1,up2,factor
      DOUBLE PRECISION xx !! [GeV/fm^3] 
      DOUBLE PRECISION fn,df 
      INTEGER ng,nb,nq,ns,Id,ic  
      INTEGER idst,idfn 

      COMMON/prtclms/ rgms(1000)
      COMMON/quantum/ ng(1000),nb(1000),nq(1000),ns(1000) 

      COMMON/TEMPERA/Tm 
      COMMON/CHEMPOT/ub 
      COMMON/BAGCNST/BAGCNST
      COMMON/HARDCORE/R0
      COMMON/Pex/Pex
      Pex= xx 
      Ps=  zero
      Pd=  zero 
      idst=1
      idfn=411 
      do 420 Id=idst,idfn          
         if(ng(Id).eq.0) goto 420 
CCC   ##############################################################
         bb= dble(nb(Id))
         qq= dble(nq(Id))
         ss= dble(ns(Id))
CCC   ##############################################
	 uu= bb *ub
         V0= zero 
         if(Id.ge.150) V0= four*pi*R0**3/three 
         uu= uu -V0*xx       !! [GeV] 
CCC   ###############################################
         ic=0
         dp= rgms(Id)/100.d+00
         if(dp.lt.epsilon) dp=1.d-04
         pp= dp 
         prss= zero 
         prdd= zero 
 520     continue
         ee= sqrt(pp*pp+rgms(Id)*rgms(Id))
CCC   -----------------------------------------------
CCC   Simpson's foruula(with automatic termination) 
         if(ic.eq.0) then 
            factor=uni 
         else if(mod(ic,2).eq.1) then 
            factor=four
         else if(mod(ic,2).eq.0) then
            factor=two 
         end if
CCC   -----------------------------------------------
         if((uu-ee)/Tm.gt.+299.d+00) then 
            Thermf= exp(+299.d+00) 
         else if((uu-ee)/Tm.lt.-299.d+00) then
            Thermf= exp(-299.d+00) 
         else 
            Thermf= exp((uu-ee)/Tm) !! here uu-ee !! 
         end if
CCC   -----------------------------------------------
CCC   ///////////////////////////////////////////////////////////
         if(Id.lt.150.or.Id.eq.450) then 
                                !! == Boson  (Mesons) == 
            up1= -Tm    *log(uni- Thermf)
            up2= -V0*Thermf/(uni- Thermf)
CCC   ///////////////////////////////////////////////////////////
         else                   !! == Fermion(Baryons) == 
            up1= +Tm    *log(uni+ Thermf)
            up2= -V0*Thermf/(uni+ Thermf)
         end if
CCC   /////////////////////////////////////////////////////////// 
         up1=up1*pp*pp*dp*dble(ng(Id))/(two*pi*pi)*factor/three
         up2=up2*pp*pp*dp*dble(ng(Id))/(two*pi*pi)*factor/three
         prss= prss+ up1
         prdd= prdd+ up2
         
         if(prss.gt.zero) then 
            if(up1/prss.lt.1.d-12) then !! condition of converge
               prss=prss/(hbarc*hbarc*hbarc) !![GeV/fm^3] 
               prdd=prdd/(hbarc*hbarc*hbarc) !![non] 
               goto 418
            end if
         end if
	 ic=ic+1
         if(ic.gt.25.and.prss.le.1.d-99) goto 420 
         pp=pp+dp
         goto 520
 418     continue
         Ps= Ps+ prss
         Pd= Pd+ prdd 
CCC   ##############################################################
 420  continue   
      fn= Ps- xx  
      df= Pd- uni 
      RETURN
      END


C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@



CCC   #################################################################
CCC   prss_rg .f for SPheRIO \(^^) 
CCC   for solving inverse problem 
CCC   last updated at                     Mon Sep 10 16:41:56 BRT 2001
CCC   #################################################################
      SUBROUTINE pideal(Tm,ub,Ps,phsflg) 

      IMPLICIT NONE 
      DOUBLE PRECISION zero,uni,half,two,three,four,six,epsilon
      DOUBLE PRECISION pi,pimass,hbarc 
      PARAMETER(zero=0.0000d+00,uni=1.0000d+00,half=0.5000d+00) 
      PARAMETER(two=2.000d+00,four=4.000d+00,epsilon=1.000d-08) 
      PARAMETER(three=3.000d+00,six=6.000d+00)
      PARAMETER(pi=3.141592654d+00) 
      PARAMETER(pimass=0.14d+00, hbarc= 0.197327053d+00) !![GeV*fm] 
      DOUBLE PRECISION Tm,ub,ee,bb,qq,ss
      DOUBLE PRECISION pp,dp,uu,prss,Ps,rgms,Thermf,BAGCNST
      INTEGER ng,nb,nq,ns,Id,ic  
      INTEGER phsflg,idst,idfn 
      DOUBLE PRECISION up1,factor
      COMMON/prtclms/ rgms(1000)
      COMMON/quantum/ ng(1000),nb(1000),nq(1000),ns(1000) 
      COMMON/BAGCNST/BAGCNST

      Ps=zero 
CCC   ////////////////////////////////////////////////////
      if(phsflg.eq.0) then      !! resonance gas 
         idst=1
         idfn=411 
      else if(phsflg.eq.2) then  !! quark gluon plasma 
         idst=450
         idfn=456 
      end if
CCC   ////////////////////////////////////////////////////
      do 420 Id=idst,idfn 
         if(ng(Id).eq.0) goto 420 
CCC   ##############################################################
         bb= dble(nb(Id))
         qq= dble(nq(Id))
         ss= dble(ns(Id))
         if(Id.gt.450) bb=bb/3.00d+00 
         if(Id.gt.450) qq=qq/3.00d+00 

	 uu= bb *ub
         ic=0
         dp= rgms(Id)/25.d+00
         if(dp.lt.epsilon) dp=1.d-03 

         pp= dp 
         prss= zero 
 520     continue
         ee= sqrt(pp*pp+rgms(Id)*rgms(Id))
CCC   -----------------------------------------------
CCC   Simpson's foruula(with automatic termination) 
         if(ic.eq.0) then 
            factor=uni 
         else if(mod(ic,2).eq.1) then 
            factor=four
         else if(mod(ic,2).eq.0) then
            factor=two 
         end if
CCC   -----------------------------------------------
         if((uu-ee)/Tm.gt.+299.d+00) then 
            Thermf= exp(+299.d+00) 
         else if((uu-ee)/Tm.lt.-299.d+00) then
            Thermf= exp(-299.d+00) 
         else 
            Thermf= exp((uu-ee)/Tm) !! here uu-ee !! 
         end if
CCC   -----------------------------------------------
CCC   ///////////////////////////////////////////////////////////
         if(Id.lt.150.or.Id.eq.450) then 
                                !! == Boson  (Mesons) == 
            up1 = -Tm*log(uni- Thermf)
CCC   ///////////////////////////////////////////////////////////
         else                   !! == Fermion(Baryons) == 
            up1 = +Tm*log(uni+ Thermf)
         end if
CCC   /////////////////////////////////////////////////////////// 
         up1=up1*pp*pp*dp*dble(ng(Id))/(two*pi*pi)*factor/three
         prss= prss+ up1 
         if(prss.gt.zero) then 
            if(up1/prss.lt.1.d-06) then !! condition of converge
               prss=prss/(hbarc*hbarc*hbarc) !![GeV/fm^3] 
               goto 418
            end if
         end if
	 ic=ic+1
         if(ic.gt.25.and.prss.le.1.d-99) goto 420 
         pp=pp+dp
         goto 520  
 418     continue
         Ps=Ps+ prss
CCC   ##############################################################
 420  continue   
      if(phsflg.eq.2) Ps=Ps -BAGCNST 
      RETURN
      END 



C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


CCC   #################################################################
CCC   phasedig.f for SPheRIO \(^^) 
CCC   for solving balance equation 
CCC   last updated at                     Mon Sep 10 16:41:56 BRT 2001
CCC   #################################################################
      DOUBLE PRECISION FUNCTION prdiff(ub)
      IMPLICIT NONE
      DOUBLE PRECISION zero,uni,half,two,three,four,six,epsilon
      DOUBLE PRECISION pi,pimass,hbarc
      PARAMETER(zero=0.0000d+00,uni=1.0000d+00,half=0.5000d+00)
      PARAMETER(two=2.000d+00,four=4.000d+00,epsilon=1.000d-08)
      PARAMETER(three=3.000d+00,six=6.000d+00)
      PARAMETER(pi=3.141592654d+00)
      PARAMETER(pimass=0.140d+00, hbarc= 0.197327053d+00) !![GeV*fm]
      DOUBLE PRECISION ub,Tm,Pq,Pr,Pex,Tmtr,ubtr,R0
      INTEGER phsflg
      COMMON/TEMPERA/Tmtr
      COMMON/CHEMPOT/ubtr
      COMMON/PEX/Pex
      COMMON/HARDCORE/R0
      COMMON/prpq/Pr,Pq
CCC   =========
      Tm= Tmtr
      ubtr= ub
CCC   =========
CCC   finding pressure in exclusived volem corr. 
CCC   /////////////////////////////////////////////// 
      phsflg=0  
      call findpex(Tm,ub,phsflg)   !! RG  RG  RG  
      Pr= Pex  
ccc   /////////////////////////////////////////////// 
      phsflg=2  
      call pideal(Tm,ub,Pq,phsflg)     !! QGP QGP QGP  
ccc   /////////////////////////////////////////////// 
      prdiff= Pq-Pr   
      RETURN  
      END  


C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


CCC   #################################################################
CCC   establetu.f for making a table for thermodynamical quantities 
CCC   for given T and ub 
CCC   #################################################################
CCC   last updated at 05072006
CCC   es is expend from (1:4,0:2) --> (1:5,0:2) to adopt the modification 
CCC   in geteos(), while the extra data is not used here, cuz the subroutine
CCC   is to be obsoleted
CCC   
CCC   last updated at 04302006
CCC   modified the common block mix1,mix2
CCC   spherio.mixph.inc, spherio.const.inc, spherio.fnames.inc are included                   
CCC   #################################################################
      SUBROUTINE thtable()

      IMPLICIT NONE 
      include 'spherio.const.inc'
      include 'spherio.mixph.inc'
	include 'epos.incsf'
      include 'spherio.fnames.inc'

      DOUBLE PRECISION Tm,ub,es(1:5,0:2)
      DOUBLE PRECISION Tmin,Tmax,ubmn,ubmx 
      INTEGER phsflg,mm,m2
      INTEGER it,iu,itx,iux

      CHARACTER filename1*108,filename2*108

      DOUBLE PRECISION tmm(150),ubm(150) 

      filename1= fneos(1:nfneos)//eosdatapath1//thrf1 
      filename2= fneos(1:nfneos)//eosdatapath1//thrf2 

      do mm=1,mbinx
         tmm(mm)=qgh(1,mm) !! =rgh(1,mm) 
         ubm(mm)=qgh(2,mm) !! =rgh(2,mm)
      end do
ccc   ///////////////////////////////////////////////////////////////
      phsflg=2                 !! for QGP... 
      itx=101
      iux=101 
      ubmx= 2.0d+00            !![GeV]
      ubmn= 0.0d+00            !![GeV]

      OPEN(10,FILE=filename1,status='unknown') 
      WRITE(10,'(2I6)') itx,iux 
      CLOSE(10)
      do iu=1,iux 
         ub= (ubmx-ubmn)/dble(iux-1)*dble(iu-1)+ubmn
         call locate(ubm,mbinx,ub,m2)
         if(m2.eq.mbinx) then 
            Tmin= 25.d-03 !! [=25MeV]
         else
            Tmin= min(tmm(m2+1)*0.80d+00,25.d-03)
         end if         
         Tmax= 0.350d+00 
         do it=1,itx  
            Tm= (Tmax-Tmin)/dble(itx-1)*dble(it-1)+Tmin 
            call geteos(Tm,ub,phsflg,es)
      OPEN(10,FILE=filename1,status='unknown',access='append') 
      WRITE(10,'(6d16.8)') Tm,ub,es(1,0),es(2,0),es(3,0),es(4,0) 
      CLOSE(10) 
         end do
      end do
ccc   ////////////////////////////////////////////////////////////////      
      phsflg=0         !! for resonance gas... 
      itx=101
      iux=101 

      OPEN(10,FILE=filename2,status='unknown') 
      WRITE(10,'(2I6)') itx,iux   
      CLOSE(10)
      ubmx= ubm(mbinx) !![GeV] 
      ubmn= 0.0d+00    !![GeV]      
      do iu=1,iux 
         ub= (ubmx-ubmn)/dble(iux-1)*dble(iu-1)+ubmn
         call locate(ubm,mbinx,ub,m2)         
         if(m2.eq.mbinx) then 
            Tmax= tmm(mbinx)  *1.20d+00 
            Tmin= 25.d-03!=1MeV
         else if(m2.eq.0) then 
            Tmax= tmm(m2+1)   *1.20d+00
            Tmin= 25.d-03!=1MeV
         else
            Tmax= tmm(m2)     *1.20d+00 
            Tmin= 25.d-03!=1MeV          
         end if 
         do it=1,itx
            Tm= (Tmax-Tmin)/dble(itx-1)*dble(it-1)+Tmin 
            call geteos(Tm,ub,phsflg,es)
      OPEN(10,FILE=filename2,status='unknown',access='append') 
      WRITE(10,'(6d16.8)') Tm,ub,es(1,0),es(2,0),es(3,0),es(4,0) 
      CLOSE(10) 
         end do
      end do
ccc   ////////////////////////////////////////////////////////////////
      RETURN
      STOP 
      END 


C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


CCC   #################################################################
CCC   establetu.f for making a table fot Tm and ub 
CCC   last updated
CCC   #################################################################
      SUBROUTINE tmtable()
      
      IMPLICIT NONE
      include 'spherio.const.inc'
	include 'epos.incsf'
      include 'spherio.fnames.inc'
      DOUBLE PRECISION edmax,edmin,sdmax,sdmin,nbmax,nbmin,nbmaxbf
      DOUBLE PRECISION given(3),Tm,ub
      INTEGER phsflg,mbin1,mbin2,m1,m2,gf,itflg
      CHARACTER filename11*108,filename12*108
      CHARACTER filename21*108,filename22*108

      filename11= fneos(1:nfneos)//eosdatapath1//tmuef1
      filename12= fneos(1:nfneos)//eosdatapath1//tmusf1
      filename21= fneos(1:nfneos)//eosdatapath1//tmuef2
      filename22= fneos(1:nfneos)//eosdatapath1//tmusf2

ccc   #####################################################################
ccc   Table for Quark Gluon Plasma: 
ccc   for energy density
      gf=1
      phsflg=2
      mbin1=51
      mbin2=51 
      edmax= log(21.d+00) 
      edmin= log(1.0d+00)
      OPEN(10,file=filename11,status='unknown')
      WRITE(10,'(2i8)') mbin1,mbin2 
      CLOSE(10) 
      do 101 m1=1,mbin1 
         given(gf)= (edmax-edmin)/dble(mbin1-1)*dble(m1-1)+edmin 
         given(gf)= exp(given(gf))
         
         do 102 m2=1,mbin2
            nbmax= log(given(1) *1.05d+00)
            nbmin= log(1.00d-05) 
            if(log(nbmax).gt.log(3.d+00)) nbmax=log(3.d+00)
            given(3)= (nbmax-nbmin)/dble(mbin2-1)*dble(m2-1)+nbmin 
            given(3)= exp(given(3))
            if(m2.eq.1) given(3)=zero 
            
            call gettmu(given,gf,Tm,ub,phsflg,1) 
            OPEN(10,file=filename11,status='unknown',access='append')
            WRITE(10,'(4d16.8)') given(gf),given(3),Tm,ub
            CLOSE(10)
 102     continue
 101  continue

ccc   ///////////////////////////////////////////////////////////////////
ccc   for entropy density: 
      gf=2
      phsflg=2
      mbin1=51
      mbin2=51 
      sdmax= log(90.05d+00)          !! ~ corresponding to  T=0.320d+00 
      sdmin= log(0.050d+00)
      OPEN(10,file=filename12,status='unknown')
      WRITE(10,'(2i8)') mbin1,mbin2 
      CLOSE(10)      
      do 151 m1=1,mbin1 
         given(gf)= (sdmax-sdmin)/dble(mbin1-1)*dble(m1-1)+sdmin 
         given(gf)= exp(given(gf))
         nbmax= log(2.50d+00)
         nbmin= log(1.00d-05)
         itflg= 0
 150     continue
         do 152 m2=1,mbin2 
            given(3)= (nbmax-nbmin)/dble(mbin2-1)*dble(m2-1)+nbmin
            given(3)= exp(given(3))            
            if(m2.eq.1) given(3)=zero
            
            call gettmu(given,gf,Tm,ub,phsflg,1) 
            if(itflg.eq.0.and.Tm.le.zero) then
               if(m2.le.2) stop 'error 150 in tmtable' 
               nbmax= log(nbmaxbf) 
               itflg=1
               goto 150
            end if
            if(itflg.eq.0) nbmaxbf= given(3)
            if(itflg.eq.0.and.m2.eq.mbin2) then 
               itflg=1
               goto 150
            end if
            if(itflg.eq.1) then 
               OPEN(10,file=filename12,status='unknown',access='append')
               WRITE(10,'(4d16.8)') given(gf),given(3),Tm,ub
               CLOSE(10)
            end if
 152     continue
 151  continue
ccc   #####################################################################
ccc   Table for Resonance Gas: 
      gf=1 
      phsflg=0
      mbin1=51
      mbin2=51  
      edmax=  log(0.7500d+00)
      edmin=  log(0.0050d+00) 
      OPEN(10,file=filename21,status='unknown')
      WRITE(10,'(2i8)') mbin1,mbin2 
      CLOSE(10)
      do 201 m1=1,mbin1
         given(gf)= (edmax-edmin)/dble(mbin1-1)*dble(m1-1)+edmin 
         given(gf)= exp(given(gf)) 
         do 202 m2=1, mbin2
            nbmax= log(given(1)*1.05d+00)
            nbmin= log(1.00d-05)
            given(3)= (nbmax-nbmin)/dble(mbin2-1)*dble(m2-1)+nbmin 
            given(3)= exp(given(3)) 
            if(m2.eq.1) given(3)=zero 

            call gettmu(given,gf,Tm,ub,phsflg,1) 
            OPEN(10,file=filename21,status='unknown',access='append')
            WRITE(10,'(4d16.8)') given(gf),given(3),Tm,ub
            CLOSE(10) 
 202     continue
 201  continue
ccc   ///////////////////////////////////////////////////////////////////
ccc   for entropy density: 
      gf=2 
      phsflg=0
      mbin1=51
      mbin2=51  
      sdmax=  log(2.700d+00)
      sdmin=  log(0.050d+00)
      OPEN(10,file=filename22,status='unknown')
      WRITE(10,'(2i8)') mbin1,mbin2
      CLOSE(10)
      do 251 m1=1,mbin1
         given(gf)= (sdmax-sdmin)/dble(mbin1-1)*dble(m1-1)+sdmin 
         given(gf)= exp(given(gf))          
         nbmax= log(0.65d+00) 
         nbmin= log(1.00d-05)
         itflg=0 
 250     continue
         do 252 m2=1,mbin2
            given(3)= (nbmax-nbmin)/dble(mbin2-1)*dble(m2-1)+nbmin 
            given(3)= exp(given(3))
            if(m2.eq.1) given(3)=zero
 
            call gettmu(given,gf,Tm,ub,phsflg,1)
            if(itflg.eq.0.and.Tm.le.zero) then
               if(m2.le.2) stop 'error 250 in tmtable'                
               nbmax= log(nbmaxbf)
               itflg=1
               goto 250
            end if
            if(itflg.eq.0) nbmaxbf= given(3) 
            if(itflg.eq.0.and.m2.eq.mbin2) then 
               itflg=1
               goto 250
            end if
            if(itflg.eq.1) then 
               OPEN(10,file=filename22,status='unknown',access='append')
               WRITE(10,'(4d16.8)') given(gf),given(3),Tm,ub
               CLOSE(10) 
            end if
 252     continue
 251  continue
ccc   ###################################################################
      RETURN
      END 
      






C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


