c-----------------------------------------------------------------------
      subroutine aasetspherio
c-----------------------------------------------------------------------
c     sets parameters and options, initializes counters for spehrio
c-----------------------------------------------------------------------
      implicit none
      include 'epos.incso'
	include 'epos.incsf'
      include 'spherio.temps.inc'
	include 'spherio.quifz.inc'
	include 'spherio.ce.inc'
	include 'spherio.ridge.inc'
	include 'spherio.sphsplit.inc'
	include 'spherio.eos.inc'
	include 'spherio.hbt.inc'
	include 'spherio.io.inc'
	include 'spherio.iown.inc'
      include 'spherio.seedspo.inc'
	include 'spherio.debug.inc'
	include 'spherio.hydro.inc'


      !~~~~begin optnspherio~~~~
      icemode=0     !continuous emission switch and
                    !continuous emission mode
                    !off(0) isotropic(1) or anisotropic(2)
      ifz=1           !freeze-out
      iquifz=0      !chemical freeze-out
      iquimode=1    !chemical freeze-out scenario
                    !hadron phase boundary(1) qgp phase boundary(2) chemical freeze-out temperature(3)
                    !dual temperature boundary(4) omega scenario(5) dual temperature for all particles(6)
      imhbt=0       !calculate hbt radius
      ieosmode=2    !EOS table incorporated
                    !1st order non-strangeness(1) 1st order strangeness(2) 1st order bag + massless pion(3) massless pion(4)
                    !lattice inspired non-strangeness(7) lattice inspired strangeness(8) user defined(99)
      bugflg=0      !debug flag
      itrans=0      !initial transverse expansion correction
                    !Pure NEXUS(0) or NEXUS+tanh(alpha*r)(9) rapfactor(11) Mach Cone(15)
      ihdmode=0     !hydro evolution mode
                    !normal(0) SPH particle decouples at freeze-out(1)
      itrobmd=0     !hydro evolution surveillance output mode
                    !possible numbers (0) (1) (2) (8) (9) (12) (13) (14) (15)
                    !read optns file for more instruction
      seedspo=0     !seed for spherio
      iepdbug1=0    !give epos the freedom to test spherio via TransferSpherioEpos
      iepdbug2=0    !give epos the freedom to test spherio via TransferTauNsp
      iepdbug3=0    !give epos the freedom to test spherio via TransferHydroTable
	iauxi=1       !debugging message output level, bigger number -> more detailed info
	imprs=-1      !precision mode, to run the code with the highest possible precision
	ipsplit=1     !SPH particle splitting, incorrectly referred to as decay in the code
	iridge=0      !check "ridge effect" by only printing out emission from high energy SPH particles
	rdratio=1.d0  !the percentage of energy to be used in the study of "ridge effect"
	eos(1)=1.d0   !dummy assignment
cxx	icomode=1     !IC interface
	ireadfzo=0    !whether to read freeze-out file
	imakefzo=0    !whether to make freeze-out file
	ixell=0       !whether to print out hadron emission 
	ifzlistfmt=3  !print out format of hadron emission (1)spherio (2)NEXUS/EPOS (3)THERMINATOR/SHARE (4)ROOT
	idimension=3  !3D or 2D
	iviscosity=1  !viscosity (0)ideal non linear (1)ideal iteration (2)bulk (3)bulk+shear
	thxy=1.0      !hxy
	thet=thxy     !het
	tdtau=0.25d0*thxy !dtau
	bbwn=-1.d0    !impact parameter for wounded nucleons model, negative for verification purpose
	r0tube=1.d0   ![fm] radius of tubes in fluctuating wounded nucleons model
      e0tube=1.d0   ![GeV/fm] total energy of each tube in wounded nucleons model
      !~~~~end optnspherio~~~~

      fnspo='./ '         !path spherio name
      fnhto='./ '
	fneos='./ '
      fnent='entro.data '
      fnfce='flgce.data '
      fncfz='chfz.data '
	fnsom='soma.data '
	fneda='enda.data '
	fnztr='ztr.data '
	fnnan='nan.data '
	fnnsp='nsp.data '
	fneoe='eos.data '
      fnhbt='hbt.data '
      fnfzo='fzo.data '
	fncno='auau '
      nfnspo=index(fnspo,' ')-1   !length of path spherio name
      nfnhto=index(fnhto,' ')-1
	nfneos=index(fneos,' ')-1
      nfnent=index(fnent,' ')-1
      nfnfce=index(fnfce,' ')-1
      nfncfz=index(fncfz,' ')-1
	nfnsom=index(fnsom,' ')-1
      nfneda=index(fneda,' ')-1
	nfnztr=index(fnztr,' ')-1
	nfnnan=index(fnnan,' ')-1
	nfnnsp=index(fnnsp,' ')-1
	nfneoe=index(fneoe,' ')-1
	nfnhbt=index(fnhbt,' ')-1
	nfnfzo=index(fnfzo,' ')-1
	nfncno=index(fncno,' ')-1

      return
      end


c---------------------------------------------------------------------
c  reads and interprets input commands for spherio
c---------------------------------------------------------------------
      subroutine spherioptn(line,j)
      include 'epos.inc'
      include 'epos.incso'
	include 'epos.incsf'
      include 'spherio.temps.inc'
      include 'spherio.io.inc'
	include 'spherio.iown.inc'
	include 'spherio.quifz.inc'
	include 'spherio.ce.inc'
	include 'spherio.ridge.inc'
	include 'spherio.sphsplit.inc'
	include 'spherio.eos.inc'
	include 'spherio.hbt.inc'
      include 'spherio.seedspo.inc'
	include 'spherio.debug.inc'
	include 'spherio.hydro.inc'

      character*160 line,linex
      double precision val
	integer i,j,ix,jx
	integer ne
	integer trireadfzo

      eos(1)=1.d0         !dummy assignment
c      j=-1

    1 call utword(line,i,j,1)

            if(line(i:j).eq.'beginoptns')then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')
     &                             'spherio nexus or epos?'
      call utword(line,i,j,0)
      linex=line
      ix=i
      jx=j

      !~~~~begin optnspherio~~~~
      if(linex(ix:jx).eq.'spherio')stop 'beginoptns miss match!'
      if(linex(ix:jx).eq.'epos')stop 'beginoptns miss match!'
      if(linex(ix:jx).eq.'nexus')stop 'beginoptns miss match!'
      if(linex(ix:jx).eq.'nonhydro')stop 'beginoptns miss match!'
      !~~~~end optnspherio~~~~

           elseif(line(i:j).eq.'endoptns')then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')
     &                              'spherio nexus or epos?'
      call utword(line,i,j,0)
      linex=line
      ix=i
      jx=j
      !~~~~begin optnspherio~~~~
      if(linex(ix:jx).eq.'spherio')return
      if(linex(ix:jx).eq.'epos')stop 'endoptns miss match!'
      if(linex(ix:jx).eq.'nexus')stop 'endoptns miss match!'
      if(linex(ix:jx).eq.'nonhydro')stop 'endoptns miss match!'
      !~~~~end optnspherio~~~~

           elseif(line(i:j).eq.'fname')then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'file-type file-name?' 
      call utword(line,i,j,0)
      linex=line
      ix=i
      jx=j
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'file-name?'
      call utword(line,i,j,0)

      !~~~~begin optnspherio~~~~
      if(linex(ix:jx).eq.'pathspo')fnspo(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'pathspo')nfnspo=j-i+1
      if(linex(ix:jx).eq.'patheos')fneos(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'patheos')nfneos=j-i+1
      if(linex(ix:jx).eq.'pathhto')fnhto(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'pathhto')nfnhto=j-i+1
      if(linex(ix:jx).eq.'cnome')fncno(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'cnome')nfncno=j-i+1
      if(linex(ix:jx).eq.'flgfp') fnent(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'flgfp')nfnent=j-i+1
      if(linex(ix:jx).eq.'flgce') fnfce(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'flgce')nfnfce=j-i+1
      if(linex(ix:jx).eq.'chfz') fncfz(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'chfz')nfncfz=j-i+1
      if(linex(ix:jx).eq.'soma') fnsom(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'soma')nfnsom=j-i+1
      if(linex(ix:jx).eq.'enda') fneda(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'enda')nfneda=j-i+1
      if(linex(ix:jx).eq.'ztr') fnztr(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'ztr')nfnztr=j-i+1
      if(linex(ix:jx).eq.'nan') fnnan(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'nan')nfnnan=j-i+1
      if(linex(ix:jx).eq.'nsp') fnnsp(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'nsp')nfnnsp=j-i+1
      if(linex(ix:jx).eq.'eos') fneoe(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'eos')nfneoe=j-i+1
      if(linex(ix:jx).eq.'hbt') fnhbt(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'hbt')nfnhbt=j-i+1
      if(linex(ix:jx).eq.'fzout') fnfzo(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'fzout')nfnfzo=j-i+1
      if(linex(ix:jx).eq.'xell') fnxll(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'xell')nfnxll=j-i+1
      !~~~~end optnspherio~~~~

           elseif(line(i:j).eq.'set')then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'p/o-name p/o-value?'
      call utword(line,i,j,0)
      linex=line
      ix=i
      jx=j
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'p/o-value?'
      call utword(line,i,j,0)
      read(line(i:j),*)val

      !~~~~begin optnspherio~~~~
      if(linex(ix:jx).eq.'ieos')ieosmode=int(val)
      if(linex(ix:jx).eq.'ibugflg')bugflg=int(val)
      if(linex(ix:jx).eq.'iprtflg')iauxi=int(val)
      if(linex(ix:jx).eq.'ihydromode')ihdmode=int(val)
      if(linex(ix:jx).eq.'itrobmode')itrobmd=int(val)
      if(linex(ix:jx).eq.'itrinimode')itrans=int(val)
      if(linex(ix:jx).eq.'iquimmode')iquimode=int(val)
      if(linex(ix:jx).eq.'idimension')idimension=sngl(val)
	if(linex(ix:jx).eq.'iviscosity')iviscosity=sngl(val)
	if(linex(ix:jx).eq.'idecomode')then
      if(icemode.ne.0)icemode=int(val)        !when it is off, don't do anything
	endif
      if(linex(ix:jx).eq.'icomode')then
      icomode=int(val)
	endif
	if(linex(ix:jx).eq.'ifzlistfmt')ifzlistfmt=sngl(val)
!it is implemented differently in epos and nexus,
!it is assigned to tauico in nexus, but taumin in epos
!it is NOT handled here in spherio
ccc     if(linex(ix:jx).eq.'tempoico')tauico=sngl(val)
      if(linex(ix:jx).eq.'tempfzout')Tf=sngl(val)
      if(linex(ix:jx).eq.'tempfinal')Tfin=sngl(val)
      if(linex(ix:jx).eq.'tempqmout')Tch=sngl(val)
      if(linex(ix:jx).eq.'kappa')kappa=sngl(val)
      if(linex(ix:jx).eq.'seedspo')seedspo=sngl(val)
      if(linex(ix:jx).eq.'ridgeratio')rdratio=sngl(val)
	if(linex(ix:jx).eq.'hxy')thxy=sngl(val)
	if(linex(ix:jx).eq.'het')thet=sngl(val)
	if(linex(ix:jx).eq.'dtau')tdtau=sngl(val)
	if(linex(ix:jx).eq.'e0tube')e0tube=sngl(val)
	if(linex(ix:jx).eq.'r0tube')r0tube=sngl(val)
	!~~~~end optnspherio~~~~

           elseif(line(i:j).eq.'read')then

      call utword(line,i,j,0)
	!~~~~begin optnspherio~~~~
      if(line(i:j).eq.'fzout'.or.line(i:j).eq.'fzoutTable')then
        ireadfzo=1
        trireadfzo=ireadfzo
        call TransferSpherioEpos1(trireadfzo)
        call utword(line,i,j,0)
        if(line(i:j).eq.'$EPO')then
          call utword(line,i,j,0)
          nfnfzo=nfnnx+j-i+1
          fnfzo(1:nfnfzo)=fnnx(1:nfnnx)//line(i:j)
        elseif(line(i:j).eq.'-')then
          continue
        else
          stop '\n\n in spherioptn/read (1) \n\n'
        endif


      endif
	!~~~~end optnspherio~~~~

           elseif(line(i:j).eq.'write')then
 
      call utword(line,i,j,0)
	!~~~~begin optnspherio~~~~
      if(line(i:j).eq.'fzout'.or.line(i:j).eq.'fzoutTable')then
        imakefzo=1
      endif
	!~~~~end optnspherio~~~~

	
           elseif(line(i:j).eq.'switch')then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'option on/off?' 
      call utword(line,i,j,0)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'on/off?' 

      !~~~~begin optnspherio~~~~
        if(line(i:j).eq.'emcontinua')then
      call utword(line,i,j,0)
      if(line(i:j).eq.'on' )then
          if (icemode.eq.0)icemode=1      !turn it on only when it is off, or it might alter the mode it has been set
	endif
      if(line(i:j).eq.'off') icemode=0
        elseif(line(i:j).eq.'freezeout')then
      call utword(line,i,j,0)
      if(line(i:j).eq.'on' ) ifz=1
      if(line(i:j).eq.'off') ifz=0
        elseif(line(i:j).eq.'quimfz')then
      call utword(line,i,j,0)
      if(line(i:j).eq.'on' ) iquifz=1
      if(line(i:j).eq.'off') iquifz=0
        elseif(line(i:j).eq.'ihbt')then
      call utword(line,i,j,0)
      if(line(i:j).eq.'on' ) imhbt=1
      if(line(i:j).eq.'off') imhbt=0
        elseif(line(i:j).eq.'epoheos')then
      call utword(line,i,j,0)
      if(line(i:j).eq.'on' ) iepdbug1=1
      if(line(i:j).eq.'off') iepdbug1=0
        elseif(line(i:j).eq.'epohtau')then
      call utword(line,i,j,0)
      if(line(i:j).eq.'on' ) iepdbug2=1
      if(line(i:j).eq.'off') iepdbug2=0
        elseif(line(i:j).eq.'epohtab')then
      call utword(line,i,j,0)
      if(line(i:j).eq.'on' ) iepdbug3=1
      if(line(i:j).eq.'off') iepdbug3=0
        elseif(line(i:j).eq.'mprcsion')then
      call utword(line,i,j,0)
      if(line(i:j).eq.'on' ) imprs=1
      if(line(i:j).eq.'off') imprs=0
        elseif(line(i:j).eq.'sphsplit')then
      call utword(line,i,j,0)
      if(line(i:j).eq.'on' ) ipsplit=1
      if(line(i:j).eq.'off') ipsplit=0
        elseif(line(i:j).eq.'ridgechk')then
      call utword(line,i,j,0)
      if(line(i:j).eq.'on' ) iridge=1
      if(line(i:j).eq.'off') iridge=0
        elseif(line(i:j).eq.'xell')then
      call utword(line,i,j,0)
      if(line(i:j).eq.'on' ) ixell=1
      if(line(i:j).eq.'off') ixell=0
	  else
      write(ifmt,'(a,a,a)')'spherio optns "',line(i:j),'" not found'
      j=160
      stop
	  endif
	!~~~~end optnspherio~~~~

   
           else

      write(ifmt,'(a,a,a)')'spherio optns "',line(i:j),'" not found'
      j=160
      stop

           endif

      i=j+1
      goto 1

      end
 
