CCC   #################################################################
CCC   findph()
CCC   #################################################################
CCC   last updated
CCC   #################################################################
      SUBROUTINE findph(x,y,phi)
      IMPLICIT NONE
      double precision x,y,phi,pi
      PARAMETER(pi=3.1415926)
      IF(x.EQ.0.)THEN
         IF(y.GE.0)phi=pi/2.
         IF(y.LT.0)phi=3.*pi/2.
      ELSEIF(x.GT.0.)THEN
         IF(y.GE.0)phi=ATAN(y/x)
         IF(y.LT.0)phi=2.*pi-ATAN(ABS(y)/x)
      ELSEIF(x.LT.0.)THEN
         IF(y.GE.0)phi=pi-ATAN(y/ABS(x))
         IF(y.LT.0)phi=pi+ATAN(ABS(y)/ABS(x))
      ENDIF
      RETURN
      END



CCC   #################################################################
CCC   findth()
CCC   #################################################################
      SUBROUTINE findth(x,r,theta)
      IMPLICIT NONE
      double precision x,r,theta,pi
      PARAMETER(pi=3.1415926)
      IF(x.EQ.0.)THEN
         theta=pi/2.
      ELSEIF(x.GT.0.)THEN
         theta=ACOS(x/r)
      ELSEIF(x.LT.0.)THEN
         theta=pi-ACOS(ABS(x)/r)
      ENDIF
      RETURN
      END



CCC   #################################################################
CCC   gammln2()
CCC   #################################################################
CCC   last updated
CCC   #################################################################
      FUNCTION gammln2(xx)
      IMPLICIT NONE
	include 'spherio.debug.inc'
	include 'epos.incsf'
      REAL gammln2,xx
      INTEGER j
      DOUBLE PRECISION ser,stp,tmp,x,y,cof(6)
      SAVE cof,stp
      DATA cof,stp/76.18009172947146d0,-86.50532032941677d0,
     *24.01409824083091d0,-1.231739572450155d0,.1208650973866179d-2,
     *-.5395239384953d-5,2.5066282746310005d0/
      x=xx
      y=x
      tmp=x+5.5d0
CCC   #################################################################
CCC   NaN catchup
      if (iauxi.ge.5) then
	if (tmp.le.0.d0) then
      open(11,file=fnnan(1:nfnnan),access='append')
      write(11,*)'NaN in gammln2!'
	write(11,'(a,f16.8)')'tmp=',tmp
      close(11)
	endif
	endif
CCC   #################################################################
      tmp=(x+0.5d0)*log(tmp)-tmp

      ser=1.000000000190015d0
      do 11 j=1,6
        y=y+1.d0
        ser=ser+cof(j)/y
11    continue
CCC   #################################################################
CCC   NaN catchup
      if (iauxi.ge.5) then
	if (stp*ser/x.le.0.d0) then
      open(11,file=fnnan(1:nfnnan),access='append')
      write(11,*)'NaN in gammln2!'
	write(11,'(a,f16.8)')'stp*ser/x=',stp*ser/x 
      close(11)
	endif
	endif
CCC   #################################################################
      gammln2=tmp+log(stp*ser/x)
      return
      END



CCC   #################################################################
CCC   gammln2r()
CCC   #################################################################
CCC   last updated
CCC   #################################################################
      FUNCTION gammln2r(xx)
      IMPLICIT NONE
	include 'spherio.debug.inc'
	include 'epos.incsf'
      double precision gammln2r,xx
      INTEGER j
      DOUBLE PRECISION ser,stp,tmp,x,y,cof(6)
      SAVE cof,stp
      DATA cof,stp/76.18009172947146d0,-86.50532032941677d0,
     *24.01409824083091d0,-1.231739572450155d0,.1208650973866179d-2,
     *-.5395239384953d-5,2.5066282746310005d0/
      x=xx
      y=x
      tmp=x+5.5d0
CCC   #################################################################
CCC   NaN catchup
      if (iauxi.ge.5) then
	if (tmp.le.0.d0) then
      open(11,file=fnnan(1:nfnnan),access='append')
      write(11,*)'NaN in gammln2!'
	write(11,'(a,f16.8)')'tmp=',tmp
      close(11)
	endif
	endif
CCC   #################################################################
      tmp=(x+0.5d0)*log(tmp)-tmp

      ser=1.000000000190015d0
      do 11 j=1,6
        y=y+1.d0
        ser=ser+cof(j)/y
11    continue
CCC   #################################################################
CCC   NaN catchup
      if (iauxi.ge.5) then
	if (stp*ser/x.le.0.d0) then
      open(11,file=fnnan(1:nfnnan),access='append')
      write(11,*)'NaN in gammln2!'
	write(11,'(a,f16.8)')'stp*ser/x=',stp*ser/x 
      close(11)
	endif
	endif
CCC   #################################################################
      gammln2r=tmp+log(stp*ser/x)
      return
      END



CCC   #################################################################
CCC   Numerical Recipes routine.
CCC   Returns a normally distributed deviate with zero mean and unit 
CCC   variance, using ran2r(idum) as the source of uniform deviates.
CCC   #################################################################
      FUNCTION gasdev(idum)
      IMPLICIT NONE
      INTEGER           idum
      double precision  gasdev
      INTEGER           iset
      double precision  fac,gset,rsq,v1,v2,ran2r
      SAVE              iset,gset
      DATA iset/0/
      IF (iset.EQ.0) THEN
1       v1=2.*ran2r(idum)-1.
        v2=2.*ran2r(idum)-1.
        rsq=v1**2+v2**2
        IF(rsq.GE.1..OR.rsq.EQ.0.)GOTO 1
        fac=SQRT(-2.*LOG(rsq)/rsq)
        gset=v1*fac
        gasdev=v2*fac
        iset=1
      ELSE
        gasdev=gset
        iset=0
      ENDIF
      RETURN
      END 



CCC   #################################################################
CCC   Numerical recipes in Fortran 77. 
CCC   Cambridge University press, 1986. 
CCC   Chapter2. Solution of Linear Algebraic Equations
CCC   Section2.1 Guass Jordan Elimination, pg.27. 
CCC   Note: For larger matrix, use at least LU decomposition
CCC   #################################################################
      SUBROUTINE gaussj(a,n,np,b,m,mp)
      INTEGER m,mp,n,np,NMAX
      double precision a(np,np),b(np,mp)
      PARAMETER (NMAX=50)
      INTEGER i,icol,irow,j,k,l,ll,indxc(NMAX),indxr(NMAX),ipiv(NMAX)
      double precision big,dum,pivinv
      do 11 j=1,n
        ipiv(j)=0
11    continue
      do 22 i=1,n
        big=0.
        do 13 j=1,n
          if(ipiv(j).ne.1)then
            do 12 k=1,n
              if (ipiv(k).eq.0) then
                if (abs(a(j,k)).ge.big)then
                  big=abs(a(j,k))
                  irow=j
                  icol=k
                endif
              else if (ipiv(k).gt.1) then
	          print*,'singular matrix in gaussj'
                stop 
              endif
12          continue
          endif
13      continue
        ipiv(icol)=ipiv(icol)+1
        if (irow.ne.icol) then
          do 14 l=1,n
            dum=a(irow,l)
            a(irow,l)=a(icol,l)
            a(icol,l)=dum
14        continue
          do 15 l=1,m
            dum=b(irow,l)
            b(irow,l)=b(icol,l)
            b(icol,l)=dum
15        continue
        endif
        indxr(i)=irow
        indxc(i)=icol
        if (a(icol,icol).eq.0.) then
	    print*,'singular matrix in gaussj'
	    stop 
        endif
        pivinv=1./a(icol,icol)
        a(icol,icol)=1.
        do 16 l=1,n
          a(icol,l)=a(icol,l)*pivinv
16      continue
        do 17 l=1,m
          b(icol,l)=b(icol,l)*pivinv
17      continue
        do 21 ll=1,n
          if(ll.ne.icol)then
            dum=a(ll,icol)
            a(ll,icol)=0.
            do 18 l=1,n
              a(ll,l)=a(ll,l)-a(icol,l)*dum
18          continue
            do 19 l=1,m
              b(ll,l)=b(ll,l)-b(icol,l)*dum
19          continue
          endif
21      continue
22    continue
      do 24 l=n,1,-1
        if(indxr(l).ne.indxc(l))then
          do 23 k=1,n
            dum=a(k,indxr(l))
            a(k,indxr(l))=a(k,indxc(l))
            a(k,indxc(l))=dum
23        continue
        endif
24    continue
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 4+1$!].


C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


CCC   #################################################################
CCC   Numerical recipes in Fortran 77. 
CCC   Cambridge University press, 1986. 
CCC   Chapter8. Sorting 
CCC   Section4. Indexing and Ranking, pp329. 
CCC   #################################################################
      SUBROUTINE indexx(n,nd,arr,indx)
      include 'spherio.inc'

      INTEGER n,M,NSTACK
      PARAMETER (M=7,NSTACK=50)
      INTEGER i,indxt,ir,itemp,j,jstack,k,l,istack(NSTACK)
      DOUBLE PRECISION a
      INTEGER           indx(nd)
      DOUBLE PRECISION  arr(nd)
      do 11 j=1,n
        indx(j)=j
 11   continue
      jstack=0
      l=1
      ir=n
 1    if(ir-l.lt.M)then
         do 13 j=l+1,ir
            indxt=indx(j)
            a=arr(indxt)
            do 12 i=j-1,l,-1
               if(arr(indx(i)).le.a)goto 2
               indx(i+1)=indx(i)
 12         continue
            i=l-1
 2          indx(i+1)=indxt
 13      continue
         if(jstack.eq.0)return
         ir=istack(jstack)
         l=istack(jstack-1)
         jstack=jstack-2
      else
         k=(l+ir)/2
         itemp=indx(k)
         indx(k)=indx(l+1)
         indx(l+1)=itemp
         if(arr(indx(l)).gt.arr(indx(ir)))then
            itemp=indx(l)
            indx(l)=indx(ir)
            indx(ir)=itemp
         endif
         if(arr(indx(l+1)).gt.arr(indx(ir)))then
            itemp=indx(l+1)
            indx(l+1)=indx(ir)
            indx(ir)=itemp
         endif
         if(arr(indx(l)).gt.arr(indx(l+1)))then
            itemp=indx(l)
            indx(l)=indx(l+1)
            indx(l+1)=itemp
         endif
         i=l+1
         j=ir
         indxt=indx(l+1)
         a=arr(indxt)
 3       continue
         i=i+1
         if(arr(indx(i)).lt.a)goto 3
 4       continue
         j=j-1
         if(arr(indx(j)).gt.a)goto 4
         if(j.lt.i)goto 5
         itemp=indx(i)
         indx(i)=indx(j)
         indx(j)=itemp
         goto 3
 5       indx(l+1)=indx(j)
         indx(j)=indxt
         jstack=jstack+2
         if(jstack.gt.NSTACK)then
	    print*,'NSTACK too small in indexx'
	    stop 
	   endif
         if(ir-i+1.ge.j-l)then
            istack(jstack)=ir
            istack(jstack-1)=i
            ir=j-1
         else
            istack(jstack)=j-1
            istack(jstack-1)=l
            l=i
         endif
      endif
      goto 1
      END


C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@



CCC   #################################################################
CCC   itrp2d()
CCC   #################################################################
CCC   last updated
CCC   #################################################################
      subroutine itrp2d(xa,ya,fa,nx,ny,x,y,f)
      implicit none
      integer nx,ny
      double precision xa(nx),ya(nx,ny),fa(nx,ny)
      double precision x,y,f
      double precision ya1(ny),ya2(ny),fa1,fa2,pp
      integer jx,jy1,jy2,i

      call locate(xa,nx,x,jx)
      if(jx.eq.0 .or. jx.eq.nx) then 
           write(99,*)xa(1),xa(nx),x
           stop 'out of range -x in itrp2d'
      endif

      do i=1,ny
         ya1(i)=ya(jx  ,i)
         ya2(i)=ya(jx+1,i)
      enddo

      call locate(ya1,ny,y,jy1)
c      if(jy1.eq.0 .or. jy1.eq.ny) then 
c        write(*,*)x,y,ya1(1),ya1(ny)
c        write(*,*) 'warning: out of range -y1 in itrp2d'
c      endif
      if(jy1.eq.0)  jy1=1
      if(jy1.eq.ny) jy1=ny-1

      pp=(y-ya1(jy1))/(ya1(jy1+1)-ya1(jy1))
      fa1=(1d0-pp)*fa(jx,jy1)+pp*fa(jx,jy1+1)

      call locate(ya2,ny,y,jy2)
c      if(jy2.eq.0 .or. jy2.eq.ny) then 
c        write(*,*)x,y,ya2(1),ya2(ny)
c        write(*,*) 'warning: out of range -y2 in itrp2d'
c      endif
      if(jy2.eq.0)  jy2=1
      if(jy2.eq.ny) jy2=ny-1

      pp=(y-ya2(jy2))/(ya2(jy2+1)-ya2(jy2))
      fa2=(1d0-pp)*fa(jx+1,jy2)+pp*fa(jx+1,jy2+1)

      pp=(x-xa(jx))/(xa(jx+1)-xa(jx))
      f=(1d0-pp)*fa1+pp*fa2

      return
      end



CCC   #################################################################
CCC   Numerical recipes in Fortran 77. 
CCC   Cambridge University press, 1986. 
CCC   Chapter3. Interpolation and Extrapolation 
CCC   Section4. How to Search an Ordered Table, pg.110. 
CCC   #################################################################
      SUBROUTINE locate(xx,n,x,j)
      INTEGER j,n
      DOUBLE PRECISION x,xx(500) !! change
      INTEGER jl,jm,ju
      jl=0
      ju=n+1
      if(n.gt.500) stop 'locate warning, n>500' 
10    if(ju-jl.gt.1)then
        jm=(ju+jl)/2
        if((xx(n).ge.xx(1)).eqv.(x.ge.xx(jm)))then
          jl=jm
        else
          ju=jm
        endif
      goto 10
      endif
      if(x.eq.xx(1))then
        j=1
      else if(x.eq.xx(n))then
        j=n-1
      else
        j=jl
      endif
      return
      END



C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


CCC   #################################################################
CCC   Numerical recipes in Fortran 77. 
CCC   Cambridge University press, 1986. 
CCC   Chapter3. Interpolation and Extrapolation 
CCC   Section4. How to Search an Ordered Table, pg.110. 
CCC   #################################################################
CCC   last updated 08012006
CCC	the low boundary of the array is 1 while not 0
CCC	the subroutine returns 0 while it is out of low boundary
CCC   the subroutine returns n while it is out of high boundary
CCC   the subroutine returns a value between 1 and n-1 while it works out well
CCC   #################################################################
      SUBROUTINE locate1(xx,n,x,j)
	  implicit none
      INTEGER j,n
      DOUBLE PRECISION x,xx(1:500) !! change
      INTEGER jl,jm,ju
      jl=1
      ju=n
      if(n.gt.500) stop 'locate warning, n>500'
10    if(ju-jl.gt.1)then
        jm=(ju+jl)/2
        if((xx(n).ge.xx(1)).eqv.(x.ge.xx(jm)))then
          jl=jm
        else
          ju=jm
        endif
      goto 10
      endif
      if(x.lt.xx(1))then
        j=0
      else if(x.ge.xx(n))then
        j=n
      else
        j=jl
      endif
      return
      END
!   #####################################################################
!   #####################################################################CCC   #################################################################
CCC   mnewt()
CCC   #################################################################
      SUBROUTINE mnewt(ntrial,x,n,tolx,tolf,given,gf,phsflg)
      INTEGER n,ntrial,NP,gf,phsflg
      DOUBLE PRECISION tolf,tolx,x(n),given(3),dx(n)
      PARAMETER (NP=2)
CU    USES lubksb,ludcmp,usrfun
      INTEGER i,k
      DOUBLE PRECISION errf,errx,fjac(NP,NP),fvec(NP),p(NP)
      tempx1=x(1)
      tempx2=x(2)
      do 14  k=1,ntrial
        call usrfun(x,n,fvec,fjac,given,gf,phsflg)
        errf=0.d0
        do 11 i=1,n
          errf=errf+abs(fvec(i))
11      continue
        if(errf.le.tolf)return
        do 12 i=1,n
          p(i)=-fvec(i)
12      continue
c------------------------------------------------------------
        dx(1)=p(1)*fjac(2,2)-p(2)*fjac(1,2)
        dx(2)=p(2)*fjac(1,1)-p(1)*fjac(2,1)
        dx(1)=dx(1)/(fjac(1,1)*fjac(2,2)-fjac(2,1)*fjac(1,2))
        dx(2)=dx(2)/(fjac(1,1)*fjac(2,2)-fjac(2,1)*fjac(1,2))        
        errx=0.d0
        do 13 i=1,n
           errx=errx+abs(dx(i))
           x(i)=x(i)+dx(i)
 13     continue   
c------------------------------------------------------------
c        call ludcmp(fjac,n,NP,indx,d)
c        call lubksb(fjac,n,NP,indx,p)
c        errx=0.d0
c        do 13 i=1,n
c          errx=errx+abs(p(i))
c          x(i)=x(i)+p(i)
c13      continue
        if(errx.le.tolx)return
        if(x(1).lt.0.d0 .or. abs(x(2)).gt.15.d0) goto 15
14    continue
 15   continue
      x(1)=tempx1
      x(2)=tempx2
      return
      END


CCC   ################################################################
CCC   This program is based on; 
CCC   Numerical recipes in Fortran 77. 
CCC   Cambridge University press, 1986. 
CCC   Chapter9. Root Finding and Nonlinear Sets of Equations 
CCC   Section6. Newton-Raphson Method for Nonlinear...   , pp374. 
CCC   ################################################################
CCC   last updated 05072006
CCC   es is expend from (1:4,0:2) --> (1:5,0:2) to adopt the 
CCC   modification in geteos(), while the extra data is not used here
CCC   ################################################################
      SUBROUTINE mnewtgetmu(ntrial,x,n,tolx,tolf,given,gf,phsflg)
      IMPLICIT NONE 

      INTEGER n,ntrial,NP
      INTEGER gf,phsflg
      DOUBLE PRECISION tolf,tolx,x(2),dx(2) !! originally x(n),d(2)
      DOUBLE PRECISION given(3)
      DOUBLE PRECISION Tm,ub,es(1:5,0:2)
      PARAMETER (NP=2)
CCC   USES lubksb,ludcmp and usrfun
      INTEGER i,k
      DOUBLE PRECISION errf,fjac(NP,NP),fvec(NP),p(NP)
c	double precision errx

      do 14  k=1,ntrial
CCC   ########################################################
CCC   here is a usrfun: 
        Tm= x(1) 
        ub= x(2)                  
c       write(6,*) 'Tm=',Tm, ' ub=',ub
c       write(6,*) '///////////////////////////////////////'
        call geteos(Tm,ub,phsflg,es)
        fvec(1)=   es(gf,0)  -given(gf)
        fvec(2)=   es(3,0)   -given(3)
        fjac(1,1)= es(gf,1) 
        fjac(1,2)= es(gf,2) 
        fjac(2,1)= es(3,1)
        fjac(2,2)= es(3,2)         
CCC   ########################################################
        errf=0.d0
        do 11 i=1,n
           errf=errf+abs(fvec(i))
 11     continue
        if(errf.le.tolf) return 
        do 12 i=1,n
           p(i)=-fvec(i)
 12     continue

c     --------------------------------------------
        dx(1)= (p(1)*fjac(2,2)-p(2)*fjac(1,2))
        dx(2)= (p(2)*fjac(1,1)-p(1)*fjac(2,1))
        dx(1)= dx(1)/(fjac(1,1)*fjac(2,2)-fjac(2,1)*fjac(1,2))
        dx(2)= dx(2)/(fjac(1,1)*fjac(2,2)-fjac(2,1)*fjac(1,2))
        do 13 i=1,n
           x(i)=x(i)+dx(i) 
 13     continue
c     --------------------------------------------
c        call ludcmp(fjac,n,NP,indx,d)
c        call lubksb(fjac,n,NP,indx,p)
c        errx=0.d0
c        do 13 i=1,n
c           errx=errx+abs(p(i))
c           x(i)=x(i)+p(i)
c 13     continue
c     --------------------------------------------
        if(x(1).lt.0.d+00.or.abs(x(2)).gt.15.d+00)  goto 15 
c       if(errx.le.tolx) return  
ccc   /////////////////////////////////////////
 14   continue
 15   continue
      x(1)=0.00d+00             !! no solution 
      x(2)=0.00d+00             !! or give up 
      return
ccc   /////////////////////////////////////////
      END



C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


CCC   #################################################################
CCC   newton()
CCC   metodo de Newton para resolver um sistema de equacoes 
CCC   nao lineares. Ref. Numerical Recipes
CCC   #################################################################
CCC   last updated 03312007
CCC   add more debugging info
CCC
CCC   last udpated 03292007
CCC   fix a bug
CCC
CCC   last udpated 03282007
CCC   adopt different initial time
CCC   #################################################################
      SUBROUTINE newton(tau,T,x)
      implicit none
	include 'spherio.debug.inc'
	include 'epos.incsf'
      INTEGER ntrial
      double precision tolf,tolx,x(3)
      INTEGER i,k
      double precision errf,errx,fjac(3,3),fvec(3),p(3)
      double precision dx(3),denom,T(0:3,0:3)
c      double precision lamb,sinal,phif
      parameter (ntrial=500, tolx=1.d-6, tolf=1.d-6)
      double precision tau
c      double precision v3
   
      do 14  k=1,ntrial
        call velequ(tau,T,x,fvec,fjac)
        errf=0.d0
        do 11 i=1,3
          errf=errf+abs(fvec(i))
11      continue
        if(errf.le.tolf)return
        do 12 i=1,3
          p(i)=-fvec(i)
12      continue
        denom=fjac(1,1)*fjac(2,2)*fjac(3,3)
     &       -fjac(1,1)*fjac(2,3)*fjac(3,2)
     &       -fjac(1,2)*fjac(2,1)*fjac(3,3)
     &       +fjac(1,2)*fjac(3,1)*fjac(2,3)
     &       +fjac(2,1)*fjac(1,3)*fjac(3,2)
     &       -fjac(1,3)*fjac(2,2)*fjac(3,1)
        dx(1)=p(1)*fjac(2,3)*fjac(3,2)
     &       -p(1)*fjac(2,2)*fjac(3,3)
     &       +p(2)*fjac(1,2)*fjac(3,3)
     &       -p(2)*fjac(1,3)*fjac(3,2)
     &       -p(3)*fjac(1,2)*fjac(2,3)
     &       +p(3)*fjac(1,3)*fjac(2,2)
        dx(2)=p(1)*fjac(3,1)*fjac(2,3)
     &       -p(1)*fjac(2,1)*fjac(3,3)
     &       +p(2)*fjac(1,1)*fjac(3,3)
     &       -p(2)*fjac(1,3)*fjac(3,1)
     &       -p(3)*fjac(1,1)*fjac(2,3)
     &       +p(3)*fjac(2,1)*fjac(1,3)
        dx(3)=p(1)*fjac(2,1)*fjac(3,2)
     &       -p(1)*fjac(2,2)*fjac(3,1)
     &       -p(2)*fjac(1,1)*fjac(3,2)
     &       +p(2)*fjac(1,2)*fjac(3,1)
     &       +p(3)*fjac(1,1)*fjac(2,2)
     &       -p(3)*fjac(1,2)*fjac(2,1)
        if(abs(denom).lt.1.d-30) then
c          lamb=(T(0,0)+T(3,3))/T(0,3)
c          sinal=-1.d0
c          if(lamb.lt.0.d0)sinal=1.d0
c          if(((tau**2)*lamb**2/4.d0).lt.1.d0)stop 'problema em newton!'
c          v3=lamb/2.d0+sinal*sqrt(lamb**2/4.d0-1.d0/tau**2)
c          if(abs(tau*v3).ge.1.d0)stop 'exceed spl em newton!'
c          x(1)=0.5d0*log((1.d0+tau*v3)/(1.d0-tau*v3))
c          x(2)=0.d0
c          x(3)=phif(0.d0,0.d0)
	   if (iauxi.ge.2) then
           open(11,file=fnnan(1:nfnnan),access='append')
           write(11,*)'exagero pequeno denom em newton()'
           write(11,*)'al-eta,beta,phi',x(1),x(2),x(3)
	   end if
         return
        endif
        dx(1)=-dx(1)/denom
        dx(2)=dx(2)/denom
        dx(3)=dx(3)/denom     
        errx=0.d0
        do 13 i=1,3
           errx=errx+abs(dx(i))
           x(i)=x(i)+dx(i)
13      continue   
        if(errx.le.tolx)return
14    continue
	if (iauxi.ge.2) then
           open(11,file=fnnan(1:nfnnan),access='append')
           write(11,*)'solucao nao encontrada em newton()'
           write(11,*)'al-eta,beta,phi',x(1),x(2),x(3)
	end if
      return
      END



CCC   #################################################################
CCC   "phif" determines an azimuthal angle by x and y componets
CCC   #################################################################
CCC   last updated
CCC   #################################################################
      DOUBLE PRECISION FUNCTION phif(px,py)
      IMPLICIT NONE 
      DOUBLE PRECISION px,py
      DOUBLE PRECISION pi,zero,two,three
      PARAMETER(zero=0.000d+00,two=2.000d+00)
      PARAMETER(three=3.000d+00,pi=3.141592654d+00)

      phif=0.d0                   !dummy initialization
      IF(px.eq.zero) THEN 
         IF(py.ge.zero) then
            phif=pi/two 
         ELSE IF(py.lt.zero) then
            phif=pi/two*three 
         END IF
      ELSE IF(px.lt.zero) THEN
         IF(py.ge.zero) THEN 
            phif=atan(py/px) +pi 
         ELSE IF(py.lt.zero) THEN 
            phif=atan(py/px) +pi
         END IF
      ELSE IF(px.gt.zero) THEN
         IF(py.ge.zero) THEN 
            phif=atan(py/px)
         ELSE IF(py.lt.zero) THEN
            phif=atan(py/px) +two*pi
         END IF
      END IF

	RETURN
      END 

CCC   #################################################################
      double precision FUNCTION phif_ridge(px,py)
      IMPLICIT NONE 
      double precision px,py
      DOUBLE PRECISION pi,zero,two,three
      PARAMETER(zero=0.000d+00,two=2.000d+00)
      PARAMETER(three=3.000d+00,pi=3.141592654d+00)
	double precision phif
	double precision tubex,tubey
	common/tube/tubex,tubey
	phif_ridge=phif(px,py)-phif(tubex,tubey)
	if (phif_ridge.lt.0.0)phif_ridge=phif_ridge+two*pi
	if (phif_ridge.lt.0.0.or.phif_ridge.gt.two*pi)then
	print*,'phif_ridge out of boundary,phif_ridge=',phif_ridge
      stop
	endif
	return
      END

	logical function check_f(phi)
	implicit none
      DOUBLE PRECISION pi,zero,two,three
      PARAMETER(zero=0.000d+00,two=2.000d+00)
      PARAMETER(three=3.000d+00,pi=3.141592654d+00)
	double precision phi
	check_f=.false.
	if ((phi.ge.0.d0).and.(phi.le.pi/6.d0))
     & check_f=.true.
	if ((phi.ge.(two*pi-pi/6.d0)).and.(phi.le.two*pi))
     & check_f=.true.
	return
	end

	logical function check_b(phi)
	implicit none
      DOUBLE PRECISION pi,zero,two,three
      PARAMETER(zero=0.000d+00,two=2.000d+00)
      PARAMETER(three=3.000d+00,pi=3.141592654d+00)
	double precision phi
	check_b=.false.
	if ((phi.ge.pi/2.d0).and.(phi.le.3.d0*pi/2.d0))
c	if ((phi.ge.pi/6.d0).and.(phi.le.11.d0*pi/6.d0))
     & check_b=.true.
	return
	end
CCC   #################################################################
CCC   #################################################################



CCC   #################################################################
CCC   poidev()
CCC   #################################################################
      FUNCTION poidev(xm,idum)
      IMPLICIT NONE
	include 'spherio.debug.inc'
	include 'epos.incsf'
      INTEGER idum
      double precision poidev,xm,PI
      PARAMETER (PI=3.141592653589793)
CU    USES gammln2,ran2
      double precision alxm,em,g,oldm,sq,t,y,gammln2r,ran2r
      SAVE alxm,g,oldm,sq
      DATA oldm /-1./
      if (xm.lt.12.)then
        if (xm.ne.oldm) then
          oldm=xm
          g=exp(-xm)
        endif
        em=-1
        t=1.
2       em=em+1.
        t=t*ran2r(idum)
        if (t.gt.g) goto 2
      else
        if (xm.ne.oldm) then
          oldm=xm
CCC   #################################################################
CCC   NaN catchup
      if (iauxi.ge.5) then
	if (xm.le.0.d0) then
      open(11,file=fnnan(1:nfnnan),access='append')
      write(11,*)'NaN in poidev!'
	write(11,'(a,f16.8)')'xm=',xm
      close(11)
	endif
	endif
CCC   #################################################################
          sq=sqrt(2.*xm)
          alxm=log(xm)
          g=xm*alxm-gammln2r(xm+1.)
        endif
1       y=tan(PI*ran2r(idum))
        em=sq*y+xm
        if (em.lt.0.) goto 1
        em=int(em)
        t=0.9*(1.+y**2)*exp(em*alxm-gammln2r(em+1.)-g)
        if (ran2r(idum).gt.t) goto 1
      endif
      poidev=em
      return
      END



CCC   #################################################################
CCC   poidevr()
CCC   #################################################################
      FUNCTION poidevr(xm,idum)
      IMPLICIT NONE
	include 'spherio.debug.inc'
	include 'epos.incsf'
      INTEGER idum
      double precision poidevr,xm,PI
      PARAMETER (PI=3.141592653589793)
CU    USES gammln2,ran2
      double precision alxm,em,g,oldm,sq,t,y,gammln2r,ran2r
      SAVE alxm,g,oldm,sq
      DATA oldm /-1./
      if (xm.lt.12.)then
        if (xm.ne.oldm) then
          oldm=xm
          g=exp(-xm)
        endif
        em=-1
        t=1.
2       em=em+1.
        t=t*ran2r(idum)
        if (t.gt.g) goto 2
      else
        if (xm.ne.oldm) then
          oldm=xm
CCC   #################################################################
CCC   NaN catchup
      if (iauxi.ge.5) then
	if (xm.le.0.d0) then
      open(11,file=fnnan(1:nfnnan),access='append')
      write(11,*)'NaN in poidev!'
	write(11,'(a,f16.8)')'xm=',xm
      close(11)
	endif
	endif
CCC   #################################################################
          sq=sqrt(2.*xm)
          alxm=log(xm)
          g=xm*alxm-gammln2r(xm+1.)
        endif
1       y=tan(PI*ran2r(idum))
        em=sq*y+xm
        if (em.lt.0.) goto 1
        em=int(em)
        t=0.9*(1.+y**2)*exp(em*alxm-gammln2r(em+1.)-g)
        if (ran2r(idum).gt.t) goto 1
      endif
      poidevr=em
      return
      END



CCC   #################################################################
CCC   Numerical recipes in Fortran 77. 
CCC   Cambridge University press, 1986. 
CCC   Chapter3. Interpolation and Extrapolation
CCC   Section1. Polynomial Interpolation and Extrapolation, pp 102
CCC   #################################################################
      SUBROUTINE polint(xa,ya,n0,n,x,y,dy)
      INTEGER n0,n
      DOUBLE PRECISION dy,x,y,xa(n0),ya(n0)
      INTEGER i,m,ns
      DOUBLE PRECISION den,dif,dift,ho,hp,w,c(3),d(3)
      ns=1
      dif=abs(x-xa(1))
      do 11 i=1,n
         dift=abs(x-xa(i))
         if (dift.lt.dif) then
            ns=i
            dif=dift
         endif
         c(i)=ya(i)
         d(i)=ya(i)
 11   continue
      y=ya(ns)
      ns=ns-1
      do 13 m=1,n-1
         do 12 i=1,n-m
            ho=xa(i)-x
            hp=xa(i+m)-x
            w=c(i+1)-d(i)
            den=ho-hp
            if(den.eq.0.d0)then
	       print*,'failure in polint'
	       stop
	      endif
            den=w/den
            d(i)=hp*den
            c(i)=ho*den
 12      continue
         if (2*ns.lt.n-m)then
            dy=c(ns+1)
         else
            dy=d(ns)
            ns=ns-1
         endif
         y=y+dy
13    continue
      return
      END
      


C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@




CCC   #################################################################
CCC   This subroutine program is based on 
CCC   Numerical recipes in Fortran 77. 
CCC   Cambridge University press, 1986. 
CCC   Chapter3. Interpolation and Extrapolation 
CCC   Section1. Polynomial Interpolation and Extrapolation, pg.103 
CCC   #################################################################
      SUBROUTINE polint11(xa,ya,n0,n,x,y,dy)
      INTEGER n,NMAX
      DOUBLE PRECISION dy,x,y,xa(n0),ya(n0)
      PARAMETER (NMAX=10)
      INTEGER i,m,ns
      DOUBLE PRECISION den,dif,dift,ho,hp,w,c(NMAX),d(NMAX)
      ns=1
      dif=abs(x-xa(1))
      do 11 i=1,n
         dift=abs(x-xa(i))
        if (dift.lt.dif) then
           ns=i
          dif=dift
       endif
        c(i)=ya(i)
        d(i)=ya(i)
 11   continue
      y=ya(ns)
      ns=ns-1
      do 13 m=1,n-1
         do 12 i=1,n-m
           ho=xa(i)-x
          hp=xa(i+m)-x
          w=c(i+1)-d(i)
          den=ho-hp
          if(den.eq.0.d0) then 
             stop 'failure in polint'
          end if
          den=w/den
          d(i)=hp*den
          c(i)=ho*den
 12    continue
       if (2*ns.lt.n-m)then
           dy=c(ns+1)
       else
           dy=d(ns)
          ns=ns-1
        endif
        y=y+dy
 13   continue
      return
      END
      




C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@



CCC   #################################################################
CCC   ran2()
CCC   #################################################################
      FUNCTION ran2(idum)
      INTEGER idum,IA,IM,IQ,IR,NTAB,NDIV
      REAL ran2,AM,EPS,RNMX
      PARAMETER (IA=16807,IM=2147483647,AM=1./IM,IQ=127773,IR=2836,
     *NTAB=32,NDIV=1+(IM-1)/NTAB,EPS=1.2e-7,RNMX=1.-EPS)
      INTEGER j,k,iv(NTAB),iy
      SAVE iv,iy
      DATA iv /NTAB*0/, iy /0/
      if (idum.le.0.or.iy.eq.0) then
        idum=max(-idum,1)
        do 11 j=NTAB+8,1,-1
          k=idum/IQ
          idum=IA*(idum-k*IQ)-IR*k
          if (idum.lt.0) idum=idum+IM
          if (j.le.NTAB) iv(j)=idum
11      continue
        iy=iv(1)
      endif
      k=idum/IQ
      idum=IA*(idum-k*IQ)-IR*k
      if (idum.lt.0) idum=idum+IM
      j=1+iy/NDIV
      iy=iv(j)
      iv(j)=idum
      ran2=min(AM*iy,RNMX)
      return
      END


CCC   #################################################################
CCC   ran2r()
CCC   #################################################################
      FUNCTION ran2r(idum)
      INTEGER idum,IA,IM,IQ,IR,NTAB,NDIV
      double precision ran2r,AM,EPS,RNMX
      PARAMETER (IA=16807,IM=2147483647,AM=1./IM,IQ=127773,IR=2836,
     *NTAB=32,NDIV=1+(IM-1)/NTAB,EPS=1.2e-7,RNMX=1.-EPS)
      INTEGER j,k,iv(NTAB),iy
      SAVE iv,iy
      DATA iv /NTAB*0/, iy /0/
      if (idum.le.0.or.iy.eq.0) then
        idum=max(-idum,1)
        do 11 j=NTAB+8,1,-1
          k=idum/IQ
          idum=IA*(idum-k*IQ)-IR*k
          if (idum.lt.0) idum=idum+IM
          if (j.le.NTAB) iv(j)=idum
11      continue
        iy=iv(1)
      endif
      k=idum/IQ
      idum=IA*(idum-k*IQ)-IR*k
      if (idum.lt.0) idum=idum+IM
      j=1+iy/NDIV
      iy=iv(j)
      iv(j)=idum
      ran2r=min(AM*iy,RNMX)
      return
      END


CCC   #################################################################
CCC   Numerical recipes in Fortran 77. 
CCC   Cambridge University press, 1986. 
CCC   Chapter7. Random Numbers, 
CCC   Section1.  Uniform Deviates, pp 273. 
CCC   #################################################################
      FUNCTION ran3(idum)
	implicit none
      INTEGER idum
      INTEGER MBIG,MSEED,MZ
C     REAL MBIG,MSEED,MZ
      DOUBLE PRECISION ran3,FAC
      PARAMETER (MBIG=1000000000,MSEED=161803398,MZ=0,FAC=1.d0/MBIG)
C     PARAMETER (MBIG=4000000.d0,MSEED=1618033.d0,MZ=0.d0,FAC=1.d0/MBIG)
      INTEGER i,iff,ii,inext,inextp,k
      INTEGER mj,mk,ma(55)
C     REAL mj,mk,ma(55)
      SAVE iff,inext,inextp,ma
      DATA iff /0/
      if(idum.lt.0.or.iff.eq.0)then
        iff=1
        mj=MSEED-iabs(idum)
        mj=mod(mj,MBIG)
        ma(55)=mj
        mk=1
        do 11 i=1,54
          ii=mod(21*i,55)
          ma(ii)=mk
          mk=mj-mk
          if(mk.lt.MZ)mk=mk+MBIG
          mj=ma(ii)
11      continue
        do 13 k=1,4
          do 12 i=1,55
            ma(i)=ma(i)-ma(1+mod(i+30,55))
            if(ma(i).lt.MZ)ma(i)=ma(i)+MBIG
12        continue
13      continue
        inext=0
        inextp=31
        idum=1
      endif
      inext=inext+1
      if(inext.eq.56)inext=1
      inextp=inextp+1
      if(inextp.eq.56)inextp=1
      mj=ma(inext)-ma(inextp)
      if(mj.lt.MZ)mj=mj+MBIG
      ma(inext)=mj
      ran3=mj*FAC
      return
      END


C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@



CCC   #################################################################
CCC   Numerical recipes in Fortran 77. 
CCC   Cambridge University press, 1986. 
CCC   Chapter9. Root Finding and NonLinear sets of Equations,
CCC   Section2. Secant, False Possition and Ridder's Method, pp347. 
CCC   #################################################################
CCC   last updated 08232007
CCC   adopt the 1/2 again 
CCC
CCC   last updated 03252007
CCC   restore the original version
CCC
CCC   last updated 03082007
CCC   modified the strategy to extrapolate the guess
CCC
CCC   last updated 08122006
CCC   debug to see what is going wrong with it
CCC   #################################################################
      FUNCTION rtflsp1(func,x1,x2,xacc)
	implicit none
	include 'spherio.debug.inc'
	include 'epos.incsf'
      INTEGER MAXIT
      DOUBLE PRECISION rtflsp1,x1,x2,xacc,func
	DOUBLE PRECISION x10,x20,f10,f20
      EXTERNAL func
      PARAMETER (MAXIT=3500)
      INTEGER j,exflg,lowtflg,lowbflg,lowsflg
      COMMON/EXF/exflg
      COMMON/LOWT/lowtflg,lowbflg,lowsflg
      DOUBLE PRECISION del,dx,f,fh,fl,swap,xh,xl

      if((x1.ge.0.d0).or.(x1.le.0.d0)) then
		continue
	else
          if (iauxi.ge.8) then
          open(11,file=fnnan(1:nfnnan),access='append')
		write(11,*)'nancatchup x1 in rtflsp1'
		write(11,*)'x1,x2=',x1,x2
		close(11)
	    endif
		stop 'rtflsp1 fatal error x1!'
	endif

      if((x2.ge.0.d0).or.(x2.le.0.d0)) then
		continue
	else
          if (iauxi.ge.8) then
          open(11,file=fnnan(1:nfnnan),access='append')
		write(11,*)'nancatchup x2 in rtflsp1'
		write(11,*)'x1,x2=',x1,x2
		close(11)
	    endif
		stop 'rtflsp1 fatal error x2!'
	endif

15	continue
      exflg=0 
      lowtflg=0
	lowbflg=0
      lowsflg=0

      fl=func(x1)    
      fh=func(x2)
CCC   #################################################################
CCC   debugging setting
	x10=x1
	x20=x2
	f10=fl
	f20=fh
CCC   #################################################################
      if(fl*fh.gt.0.d0) then
         exflg=1
         rtflsp1=0.0000d+00 
         return
      end if
      if(fl.lt.0.d0)then
         xl=x1
         xh=x2
      else
         xl=x2
         xh=x1
         swap=fl
         fl=fh
         fh=swap
      endif
      dx=xh-xl      
      do 11 j=1,MAXIT
c         rtflsp1=xl+dx*fl/(fl-fh)
         rtflsp1=.5d0*(xl+xh)
         f=func(rtflsp1)
         if(f.lt.0.d0) then
            del=xl-rtflsp1
            xl=rtflsp1
            fl=f
         else
            del=xh-rtflsp1
            xh=rtflsp1
            fh=f
         endif
         dx=xh-xl
         if(abs(del).lt.xacc.or.f.eq.0.d0)return
 11   continue

      if(lowtflg.eq.1) RETURN 
      if (iauxi.ge.5) then
      open(11,file=fnnsp(1:nfnnsp),access='append')
      WRITE(11,*) 'rtflsp1 exceed maximum iterations'
      WRITE(11,*) ' xl=',xl, ' xh=',xh
	write(11,*) 'x10=',x10,' x20=',x20
	write(11,*) 'f10=',f10,' f20=',f20
      CLOSE(11)
	endif
	lowtflg=2
c	return
      STOP 2376
      END


C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


CCC   #################################################################
CCC   Numerical recipes in Fortran 77. 
CCC   Cambridge University press, 1986. 
CCC   Chapter9. Root Finding and NonLinear sets of Equations,
CCC   Section2. Secant, False Possition and Ridder's Method, pp347. 
CCC   #################################################################
      FUNCTION rtflsp2(func,x1,x2,xacc)
	implicit none
	include 'spherio.debug.inc'
	include 'epos.incsf'
      INTEGER MAXIT
      DOUBLE PRECISION rtflsp2,x1,x2,xacc,func
      EXTERNAL func
      PARAMETER (MAXIT=250)
      INTEGER j
      DOUBLE PRECISION del,dx,f,fh,fl,swap,xh,xl
      double precision Pr,Pq,error 
      common/prpq/Pr,Pq 
      
CCC   //////////////////////////////////////////
      fl=func(x1)
      fh=func(x2)               
      if(fl*fh.gt.0.d0) then
         rtflsp2= 9.99d+99 
         return
      end if
CCC   //////////////////////////////////////////
      if(fl.lt.0.d0)then
         xl=x1
         xh=x2
      else
         xl=x2
         xh=x1
         swap=fl
         fl=fh
         fh=swap
      endif
CCC   //////////////////////////
CCC   /////////////////////////////////////////////////
      dx=xh-xl     
      do 11 j=1,MAXIT
         rtflsp2=xl+dx*fl/(fl-fh)
         f=func(rtflsp2)
         if(f.lt.0.d0) then
            del=xl-rtflsp2
            xl=rtflsp2
            fl=f
         else
            del=xh-rtflsp2
            xh=rtflsp2
            fh=f
         endif
         dx=xh-xl
ccc   here is different from the original ....
         error= 2.d+00*abs(Pr-Pq)/(Pr+Pq) 
         if(error.lt.xacc) then !! error "xacc" % 
            return
         end if
CCC   /////////////////////////////////////////////////
 11   continue
      open(11,file=fnnsp(1:nfnnsp),access='append')
      WRITE(11,*) 'rtflsp2 exceed maximum iterations'
      CLOSE(11)
      STOP 2377
      END



C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@



CCC   #################################################################
CCC   Numerical recipes in Fortran 77. 
CCC   Cambridge University press, 1986. 
CCC   Chapter9. Root Finding and NonLinear sets of Equations,
CCC   Section4. Newton-Raphson Method using Derivative 
CCC   #################################################################
      FUNCTION rtnewt(funcd,xx,xacc)
      INTEGER JMAX
      DOUBLE PRECISION rtnewt,xx,xacc
      EXTERNAL funcd
      PARAMETER(JMAX=250)
      INTEGER j
      DOUBLE PRECISION df,dx,f
      rtnewt=xx 
      do 11 j=1,JMAX
         call funcd(rtnewt,f,df)
         dx=f/df
         rtnewt=rtnewt-dx
         if(abs(dx).lt.xacc) return
 11   continue
      stop 'rtnewt exceeded maximum iterations'
      END      
CCC   #################################################################


CCC   #################################################################
CCC   velequ()
CCC   equacoes para encontrar a velocida e o respectivo jacobiano
CCC   a(1) = \alpha
CCC   a(2) = \beta
CCC   a(3) = \phi
CCC   #################################################################
CCC   last updated 03282007
CCC   adopt different initial time
CCC   #################################################################
       subroutine velequ(tau,T,a,fvec,fjac)
       implicit none
       double precision T(0:3,0:3),fvec(3),v(3),fjac(3,3),a(3)
       double precision fjac_aux(3,3)
       double precision den,xnum1,xnum2,xnum3,dv(3,3)
       double precision alpha,beta,phi
       integer i,j,k
	 double precision tau

       alpha=a(1)
       beta=a(2)
       phi=a(3)

       v(1)=tanh(beta)*cos(phi)/cosh(alpha)
       v(2)=tanh(beta)*sin(phi)/cosh(alpha)
       v(3)=tanh(alpha)/tau

       den   = T(0,0)-T(0,1)*v(1)-T(0,2)*v(2)-T(0,3)*v(3)
       xnum1 = T(1,0)-T(1,1)*v(1)-T(1,2)*v(2)-T(1,3)*v(3)
       xnum2 = T(2,0)-T(2,1)*v(1)-T(2,2)*v(2)-T(2,3)*v(3)
       xnum3 = T(3,0)-T(3,1)*v(1)-T(3,2)*v(2)-T(3,3)*v(3)
       fvec(1)=v(1)-xnum1/den
       fvec(2)=v(2)-xnum2/den
       fvec(3)=v(3)-xnum3/den
       fjac_aux(1,1)=T(1,1)/den-T(0,1)*xnum1/den**2+1.d0
       fjac_aux(1,2)=T(1,2)/den-T(0,2)*xnum1/den**2
       fjac_aux(1,3)=T(1,3)/den-T(0,3)*xnum1/den**2
       fjac_aux(2,1)=T(2,1)/den-T(0,1)*xnum2/den**2
       fjac_aux(2,2)=T(2,2)/den-T(0,2)*xnum2/den**2+1.d0
       fjac_aux(2,3)=T(2,3)/den-T(0,3)*xnum2/den**2
       fjac_aux(3,1)=T(3,1)/den-T(0,1)*xnum3/den**2
       fjac_aux(3,2)=T(3,2)/den-T(0,2)*xnum3/den**2 
       fjac_aux(3,3)=T(3,3)/den-T(0,3)*xnum3/den**2+1.d0

       if(abs(alpha).gt.50.and.abs(beta).gt.50)then
         dv(1,1)=0.d0
         dv(2,1)=0.d0
         dv(3,1)=0.d0
         dv(1,2)=0.d0
         dv(2,2)=0.d0
         dv(3,2)=0.d0
         dv(1,3)=0.d0
         dv(2,3)=0.d0
         dv(3,3)=0.d0           
       else
         dv(1,1)=-cos(phi)*tanh(beta)*sinh(alpha)/cosh(alpha)**2
         dv(2,1)=-sin(phi)*tanh(beta)*sinh(alpha)/cosh(alpha)**2 
         dv(3,1)=(1.d0-tanh(alpha)**2)/tau            !adopt different initial time
         dv(1,2)=cos(phi)*(1.d0-tanh(beta)**2)/cosh(alpha)
         dv(2,2)=sin(phi)*(1.d0-tanh(beta)**2)/cosh(alpha)
         dv(3,2)=0.d0
         dv(1,3)=-sin(phi)*tanh(beta)/cosh(alpha)
         dv(2,3)=cos(phi)*tanh(beta)/cosh(alpha)
         dv(3,3)=0.d0
       endif

       do i=1,3
         do j=1,3
           fjac(i,j)=0.d0
           do k=1,3
              fjac(i,j)=fjac(i,j)+fjac_aux(i,k)*dv(k,j)
           enddo
         enddo
       enddo
    

       return
       end





