CCC   #################################################################
CCC   SHELL MAIN PROGRAM: spherio-xell.for
CCC   Controls the flow of the code before and after
CCC   hydrodynamic model code SPheRIO is evoked
CCC   #################################################################
CCC   last udpated 20081226
CCC   The code is built based on EPOS routine aamain
CCC   #################################################################
      program aamain
      include 'epos.inc'
      include 'epos.incico'
	integer kk,n,nfr

CCC   The following will be printed on the screen
CCC   ###################################################################
CCC   #                    SPHERIO SHELL 1.00                           #
CCC   ###################################################################
      WRITE(ifmt,*)('#',kk=1,63)
      WRITE(ifmt,*)'#                       ',
     &          'SPHERIO SHELL 1.00',
     &          '                    #'
	WRITE(ifmt,*)('#',kk=1,63)

      call aaset
      call aread

      if(icotabr.eq.1)nevent=1 
      if(icotabr.eq.1)nrevt=1
      if(nfull.gt.0)nevent=nfreeze*nfull
      if(mod(nevent,nfreeze).ne.0)
     &      stop'nevent must be a multiple of nfreeze!!!!!!!!!      '

      do  n=1,nevent
          nfr=mod(n-1,nfreeze)
	    if(ispherio.eq.0)nfr=-1
          if(nfr.eq.0)call IniCon
c          if(ispherio.ne.0)then
              write(ifmt,*)'enter spherio; nfr=',nfr,' ... '
              call spherio(nrevt,nfr)
cxx              call xellwrite(nfr)
              write(ifmt,*)'exit spherio; nfr=',nfr,' ... '
c          endif
	    if(n.eq.1)call IniPar
      enddo

      end



CCC   #################################################################
CCC   SHELL SUBROUTINE PROGRAM: aaset
CCC   Program control level parameter initialization
CCC   #################################################################
CCC   last udpated 20100429
CCC   #################################################################
      subroutine aaset
      include 'epos.inc'
      include 'epos.incico'
	include 'spherio.io.inc'

      ispherio=1    !we need hydro, no?
      icomode=1     !IC interface
	ixell=1       !to set default hadronic output on from xell shell
      nevent=1      !number of events
      nfull=1       !number of full events (ico+hydro+f.o.)(if different from -1)
      nfreeze=1     !number of freeze out events per epos event

      ifop=5        !optns-file unit
      ifmt=6        !std output unit 
      ifcx=31       !check-file unit (for open)
      ifch=31       !check-file unit (for write) 
      ifhi=35       !histo-file unit
      ifdt=51       !data-file unit
      ifcp=52       !copy-file unit

	ifset=1       !set check switch
	icotabm=0     !make table for initial condition stuff
      icotabr=1     !read table for initial condition stuff
	iprmpt=-2     !on(2), off(-2), auto(1,-1)
      iecho=1       !verify option for input reading
	nopen=0       !we don't have the "second" read, only first and all
      iofrout=1     !not used, existence for epos consistency

	laproj=0      !projectile charge number
      maproj=0      !projectile mass number
      latarg=0      !target charge number
      matarg=0      !target mass number
      bmaxim=10000  !maximum impact parameter 
      bminim=0.     !minimum impact parameter
      phimax=2*3.1415927 !maximum phi
      phimin=0      !minimum phi

	tauico=1.d0   !hydro take over time (tau)
      xminico=-10.  !xrange for initial condition calculation
      xmaxico= 10.
      yminico=-10.  !yrange for initial condition calculation
      ymaxico= 10.
      zminico= -5.  !eta range for initial condition calculation
      zmaxico=  5.
      nxico=25      !lattice resolution
      nyico=25
      nzico=25

      fnnx='path/epos '         !path epos name
      fnch='zzz.check '         !check-file name
      fnhi='zzz.histo '         !histo-file name
      fndt='zzz.data '          !data-file name
      fncp='zzz.copy '          !copy-file name
	fnio='zzz.ico '
      nfnnx=index(fnnx,' ')-1   !length of path epos name
      nfnch=index(fnch,' ')-1   !length of check-file name
      nfnhi=index(fnhi,' ')-1   !length of histo-file name
      nfndt=index(fndt,' ')-1   !length of data-file name
      nfncp=index(fncp,' ')-1   !length of copy-file name
      nfnio=index(fnio,' ')-1

      RETURN
	END


CCC   #################################################################
CCC   SHELL SUBROUTINE PROGRAM: aread
CCC   Reads and interprets input commands
CCC   #################################################################
CCC   last udpated 20081226
CCC   The code is built based on EPOS routine aread
CCC   #################################################################
      subroutine aread
      include 'epos.inc'
      include 'epos.incso'
	include 'epos.incsf'
      include 'epos.incico'
    	include 'spherio.io.inc'

      character*160 line,linex
      double precision val
	integer i,j,ix,jx
	integer ne
	integer mxdefine
      parameter(mxdefine=40)
      character w1define*100,w2define*100
	integer ndefine,l1define(mxdefine),l2define(mxdefine)
      common/cdefine/ndefine,l1define,l2define
     &               ,w1define(mxdefine),w2define(mxdefine)
	integer l1,l2


      j=-1
      ndefine=0

      call aasetspherio


  199 call utword(line,i,j,1)

          if(line(i:j).eq.'#define')then
      
c	print*,'hello from define'
      call utword(line,i,j,ne)
      if(line(i:j).eq.'bim3')stop'****** bim3->bim03 ****** '
      if(line(i:j).eq.'bim5')stop'****** bim5->bim05 ****** '
      if(line(i:j).eq.'bim6')stop'****** bim6->bim06 ****** '
      if(ndefine+1.gt.mxdefine)stop'too many `define` statements.      '
      l1=j-i+1
      if(l1.gt.99)stop '`define` argument 1 too long.            '
      w1define(ndefine+1)(1:l1)=line(i:j)
      w1define(ndefine+1)(l1+1:l1+1)=' '
      call utword(line,i,j,ne)
      l2=j-i+1
      if(l2.gt.99)stop '`define` argument 2 too long.            '
      w2define(ndefine+1)(1:l2)=line(i:j)
      w2define(ndefine+1)(l2+1:l2+1)=' '
      ndefine=ndefine+1
      l1define(ndefine)=l1
      l2define(ndefine)=l2

           elseif(line(i:j).eq.'beginoptns')then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'spherio or epos?'
      call utword(line,i,j,0)
      if(line(i:j).eq.'spherio')call spherioptn(line,j)
      if(line(i:j).eq.'epos')continue
	if(line(i:j).eq.'nonhydro')continue
	
           elseif(line(i:j).eq.'endoptns')then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'spherio epos?'
      call utword(line,i,j,0)
      linex=line
      ix=i
      jx=j
      if(linex(ix:jx).eq.'spherio')stop 'beginoptns miss match!'
      if(linex(ix:jx).eq.'epos')continue
      if(linex(ix:jx).eq.'nonhydro')continue

           elseif(line(i:j).eq.'fname')then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'file-type file-name?' 
      call utword(line,i,j,0)
      linex=line
      ix=i
      jx=j
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'file-name?'
      call utword(line,i,j,0)

      if(linex(ix:jx).eq.'pathnx')fnnx(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'pathep')fnnx(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'check')fnch(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'mtr')fnmt(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'histo')fnhi(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'data') fndt(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'copy') fncp(1:j-i+1)=line(i:j)
	if(linex(ix:jx).eq.'ico')fnio(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'pathnx')nfnnx=j-i+1
      if(linex(ix:jx).eq.'pathep')nfnnx=j-i+1
      if(linex(ix:jx).eq.'check')nfnch=j-i+1
      if(linex(ix:jx).eq.'mtr')nfnmt=j-i+1
      if(linex(ix:jx).eq.'histo')nfnhi=j-i+1
      if(linex(ix:jx).eq.'data') nfndt=j-i+1
      if(linex(ix:jx).eq.'copy') nfncp=j-i+1
	if(linex(ix:jx).eq.'ico') nfnio=j-i+1


           elseif(line(i:j).eq.'echo')then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'on or off?'
      call utword(line,i,j,0)
      if(line(i:j).eq.'on')iecho=1
      if(line(i:j).eq.'off')iecho=0
      if(line(i:j).ne.'on'.and.line(i:j).ne.'off')stop'invalid option'
      if(nopen.eq.-1)iecho=0

           elseif(line(i:j).eq.'input')then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'input file?'
      call utword(line,i,j,0)
      if(nopen.ge.0)then
       nopen=nopen+1
       if(nopen.gt.9)stop'too many nested input commands'
       open(unit=20+nopen,file=line(i:j),status='old')
       if(iprmpt.eq.1)iprmpt=-1
      endif 

           elseif(line(i:j).eq.'set'.and.ifset.eq.1)then
c           elseif(line(i:j).eq.'set')then

c      print*,'hello from set! ifset=',ifset
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'p/o-name p/o-value?'
      call utword(line,i,j,0)
      linex=line
      ix=i
      jx=j
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'p/o-value?'
      call utword(line,i,j,0)
      read(line(i:j),*)val
c       general
      if(linex(ix:jx).eq.'nevent')nevent=nint(val)
      if(linex(ix:jx).eq.'nfull') nfull=nint(val)
      if(linex(ix:jx).eq.'nfreeze')nfreeze=nint(val)
c       printout options
      if(linex(ix:jx).eq.'iprmpt')iprmpt=nint(val)
c       lepton-nucleon and e+e-
      if(linex(ix:jx).eq.'ecms' )then
          ecms=sngl(val)
	    engy=ecms
	endif
      if(linex(ix:jx).eq.'icomode')then
      icomode=int(val)
	endif
c       nucleus-nucleus
      if(linex(ix:jx).eq.'laproj')laproj=nint(val)
      if(linex(ix:jx).eq.'maproj')maproj=nint(val)
      if(linex(ix:jx).eq.'latarg')latarg=nint(val)
      if(linex(ix:jx).eq.'matarg')matarg=nint(val)
      if(linex(ix:jx).eq.'bmaxim')bmaxim=sngl(val)
      if(linex(ix:jx).eq.'bminim')bminim=sngl(val)
      if(linex(ix:jx).eq.'phimax')phimax=sngl(val)
      if(linex(ix:jx).eq.'phimin')phimin=sngl(val)
c       ico
      if(linex(ix:jx).eq.'tempoico')tauico=sngl(val)
      if(linex(ix:jx).eq.'icotabm')icotabm=int(val)
      if(linex(ix:jx).eq.'icotabr')icotabr=int(val)
      if(linex(ix:jx).eq.'nxico')nxico=sngl(val)
      if(linex(ix:jx).eq.'nyico')nyico=sngl(val)
      if(linex(ix:jx).eq.'nzico')nzico=sngl(val)
      if(linex(ix:jx).eq.'xminico')xminico=sngl(val)
      if(linex(ix:jx).eq.'xmaxico')xmaxico=sngl(val)
      if(linex(ix:jx).eq.'yminico')yminico=sngl(val)
      if(linex(ix:jx).eq.'ymaxico')ymaxico=sngl(val)
      if(linex(ix:jx).eq.'zminico')zminico=sngl(val)
      if(linex(ix:jx).eq.'zmaxico')zmaxico=sngl(val)
      

            elseif(line(i:j).eq.'switch')then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'option on/off?' 
      call utword(line,i,j,0)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'on/off?' 

        if(line(i:j).eq.'WriteIcoTable'
     .     .or.line(i:j).eq.'MakeIcoTable'  )then
      call utword(line,i,j,0)
      if(line(i:j).eq.'on' )then
      icotabm=1
	icotabr=0
      endif  
      if(line(i:j).eq.'off')then
      icotabm=0
	icotabr=1
	endif
         elseif(line(i:j).eq.'ReadIcoTable')then
      call utword(line,i,j,0)
      if(line(i:j).eq.'on' )then
      icotabr=1
	icotabm=0
	endif
      if(line(i:j).eq.'off')then
      icotabr=0
	icotabm=1
	endif
         elseif(line(i:j).eq.'SPheRIO')then
      call utword(line,i,j,0)
      if(line(i:j).eq.'on' )ispherio=1
      if(line(i:j).eq.'off')ispherio=0
        endif

           elseif(line(i:j).eq.'runprogram')then
           
      if(kchopen.eq.0.and.fnch(1:nfnch).ne.'none')then
        open(unit=ifcx,file=fnch(1:nfnch),status='unknown')
        kchopen=1
      endif
      if(khiopen.eq.0.and.fnhi(1:nfnhi).ne.'none')then
        open(unit=ifhi,file=fnhi(1:nfnhi),status='unknown')
        khiopen=1
      endif
      if(kdtopen.eq.0.and.fndt(1:nfndt).ne.'none')then
        open(unit=ifdt,file=fndt(1:nfndt),status='unknown')
        kdtopen=1
      endif
      if(kcpopen.eq.0.and.fncp(1:nfncp).ne.'none')then
        open(unit=ifcp,file=fncp(1:nfncp),status='unknown')
        kcpopen=1
      endif
      return

           elseif(line(i:j).eq.'stop')then  !same as return

      if(nopen.ne.-1)then
      close(20+nopen)
      nopen=nopen-1
      if(nopen.eq.0.and.iprmpt.eq.-1)iprmpt=1
      endif

           elseif(line(i:j).eq.'stopprogram')then

      close(unit=ifcx)
      close(unit=ifhi)
      close(unit=ifdt)
      stop
	
           else

      write(ifmt,'(a,a,a)')'command "',line(i:j),'" not found'
      j=160
      stop

           endif

      i=j+1
      goto 199

      end
 

CCC   #################################################################
CCC   SHELL SUBROUTINE PROGRAM: IniCon
CCC   Reads and interprets input commands
CCC   #################################################################
CCC   inicon table means storage of IcoE, IcoV, IcoF
CCC      IcoE ... energy density in the comoving frame
CCC      IcoV ... flow velocity in hyperbolic coordinates 
CCC                 v=(vx,vy,veta=vz/tau) 
CCC                 with the velocity in the frame moving with rapidity eta
CCC      IcoF ... net flavor density in the comoving frame
CCC   the indices of these fields ix,iy,iz also refer to hyperbolic coordinates
CCC      (x,y,eta) at given tau
CCC      the corresponding grid is defined in epos.incico
CCC   #################################################################
CCC   last udpated 20081226
CCC   The code is built based on EPOS routine IniCon
CCC   #################################################################
      subroutine IniCon
      include 'epos.inc'
      include 'epos.incico'
      include 'epos.incsf'
      include 'spherio.io.inc'
      logical table
	integer laprojx,maprojx,latargx,matargx
	integer nxicox,nyicox,nzicox
      double precision engyx,bminimx,bmaximx,tauicox
	double precision xminicox,xmaxicox,yminicox,ymaxicox
      double precision zminicox,zmaxicox
	integer ikolmnx,ikolmxx
	integer i,ix,iy,iz

      
c      nfnio=nfncno+4
c      fnio(1:nfnio)=fncno(1:nfncno)//'.ico'

      if((icotabr.eq.1).and.(icomode.eq.1)) then  !read from file
      
        inquire(file=fnio(1:nfnio),exist=table)
        if(.not.table)then
          write(ifmt,'(//10x,3a//)')'STOP: file '
     *             ,fnio(1:nfnio),' not found !!!'
          stop
        endif
        write(ifmt,'(3a)')'read from ',fnio(1:nfnio),' ...'
        open(97,file=fnio(1:nfnio),status='old')
        read(97,*) iversn
        read(97,*) laprojx,maprojx,latargx,matargx
        read(97,*) engyx
        read(97,*) bminimx,bmaximx,ikolmnx,ikolmxx

        read(97,*) tauicox
        read(97,*) iabs_ninicon
        read(97,*) nxicox,nyicox,nzicox
        read(97,*)xminicox,xmaxicox,yminicox,ymaxicox,zminicox,zmaxicox
        if(laprojx.ne.laproj.or.maprojx.ne.maproj
     . .or.latargx.ne.latarg.or.matargx.ne.matarg)
     .  stop'IniCon: different nuclei\n\n'
        if(engyx.ne.engy)    
     .  stop'IniCon: different energy\n\n  '
        if(abs(bmaximx-bmaxim).gt.0.001)
     .  stop'IniCon: different min impact parameter\n\n'
        if(abs(bminimx-bminim).gt.0.001)
     .  stop'IniCon: different max impact parameter\n\n'
c	print*,'tauicox,tauico=',tauicox,tauico
        if(abs(tauicox-tauico).gt.0.001)
     .  stop'IniCon: different tauico\n\n'
        if(nxicox.ne.nxico.or.nyicox.ne.nyico
     . .or.nzicox.ne.nzico)
     .  stop'IniCon:  different nxico/nyico/nzico\n\n'
        if( xminicox.ne.xminico.or.xmaxicox.ne.xmaxico
     . .or.yminicox.ne.yminico.or.ymaxicox.ne.ymaxico
     . .or.zminicox.ne.zminico.or.zmaxicox.ne.zmaxico)
     .  stop'IniCon: different x/y/zminico or x/y/zmaxico\n\n'
        read(97,*) 
     .   (((IcoE(ix,iy,iz)         ,ix=1,nxico),iy=1,nyico),iz=1,nzico)
     . ,((((IcoV(i,ix,iy,iz),i=1,3),ix=1,nxico),iy=1,nyico),iz=1,nzico)
     . ,((((IcoF(i,ix,iy,iz),i=1,3),ix=1,nxico),iy=1,nyico),iz=1,nzico)
        close(97)

      elseif((icotabr.eq.0).and.(icomode.eq.1))then  ! calculate

        stop'Read IcoTable was not set correctly\n\n'

      elseif((icotabr.ne.1).and.(icomode.ne.1))then  ! calculate

        continue
c        stop'Icomode was set to skip the input file\n\n'

      else

        stop'IniCon: wrong choice'

      endif

      end


CCC   #################################################################
CCC   SHELL SUBROUTINE PROGRAM: IniPar
CCC   Writes the IC table to the output file
CCC   the IC information should be built somewhere else beforehand
CCC   #################################################################
CCC   inicon table means storage of IcoE, IcoV, IcoF
CCC      IcoE ... energy density in the comoving frame
CCC      IcoV ... flow velocity in hyperbolic coordinates 
CCC                 v=(vx,vy,veta=vz/tau) 
CCC                 with the velocity in the frame moving with rapidity eta
CCC      IcoF ... net flavor density in the comoving frame
CCC   the indices of these fields ix,iy,iz also refer to hyperbolic coordinates
CCC      (x,y,eta) at given tau
CCC      the corresponding grid is defined in epos.incico
CCC   #################################################################
CCC   last udpated 20100429
CCC   The code is built based on EPOS routine IniCon
CCC   #################################################################
      subroutine IniPar
      include 'epos.inc'
      include 'epos.incico'
      include 'epos.incsf'
      include 'spherio.io.inc'
      logical table
	integer i,ix,iy,iz
c	double precision rxx,ryy
c      integer ii,jj,kk
      
c      nfnio=nfncno+4
c      fnio(1:nfnio)=fncno(1:nfncno)//'.ico'

      if((icotabm.eq.1).and.(icomode.ne.1)) then  !write the file
      
        inquire(file=fnio(1:nfnio),exist=table)
        if(icotabm.eq.1.and.table)then
          write(ifmt,'(//10x,3a//)')'STOP: file '
     *             ,fnio(1:nfnio),' already exists !!!'
          stop
        endif

        write(ifmt,'(3a)')'write into ',fnio(1:nfnio),' ...'
        open(97,file=fnio(1:nfnio),status='replace')
        write(97,*) iversn
        write(97,*) laproj,maproj,latarg,matarg
        write(97,*) engy
        write(97,*) bminim,bmaxim,ikolmn,ikolmx

        write(97,*) tauico
        write(97,*) iabs_ninicon
        write(97,*) nxico,nyico,nzico
        write(97,*)xminico,xmaxico,yminico,ymaxico,zminico,zmaxico

! energy density and velocity debug and checking the output order
c      do ix=1,nxico
c          do iy=1,nyico
c	    do iz=1,nzico
c                IcoE(ix,iy,iz)=1000000*ix+1000*iy+iz
c                IcoV(1,ix,iy,iz)=0.d0 !vx
c                IcoV(2,ix,iy,iz)=0.d0 !vy
c                IcoV(3,ix,iy,iz)=0.d0 !veta
c                IcoF(1,ix,iy,iz)= zero
c                IcoF(2,ix,iy,iz)= zero
c	          IcoF(3,ix,iy,iz)= zero
c	    enddo
c          enddo
c      enddo



c	do ix=-3,3
c      do iy=-3,3
c      rxx=dble(ix*1.02d0)
c	ryy=dble(iy*1.02d0)
c      ii=int((rxx-xminico)/(xmaxico-xminico)*dble(nxico)+0.5d0)
c	jj=int((ryy-yminico)/(ymaxico-yminico)*dble(nyico)+0.5d0)
c	kk=int((0.d0-zminico)/(zmaxico-zminico)*dble(nzico)+0.5d0)
c	write(*,*)'rxx,ryy,(eta=0),IcoE(ii,jj,kk)=',rxx,ryy,IcoE(ii,jj,kk)
c      write(*,*)'ii,jj,kk=',ii,jj,kk
c      enddo
c	enddo

c      write(*,*)'IcoE(1,1,1)=',IcoE(1,1,1)
c	write(*,*)'IcoE(0)=',IcoE((nxico-1)/2,(nyico-1)/2,(nzico-1)/2)
c	write(*,*)'nxico,nyico,nzico=',nxico,nyico,nzico


        write(97,*) 
     .   (((IcoE(ix,iy,iz)         ,ix=1,nxico),iy=1,nyico),iz=1,nzico)
     . ,((((IcoV(i,ix,iy,iz),i=1,3),ix=1,nxico),iy=1,nyico),iz=1,nzico)
     . ,((((IcoF(i,ix,iy,iz),i=1,3),ix=1,nxico),iy=1,nyico),iz=1,nzico)
        close(97)

      elseif((icotabm.ne.1))then 

        continue
c        stop'Icomode was set not to read the input file\n\n'

      else

        stop'IniPar: wrong choice'

      endif

      end



      subroutine idtau(i1,pptl4,pptl5,taug)
      implicit none
	integer i1
	double precision pptl4,pptl5 !compatible with xell
      real taug !compatible with nexus
	taug=1.d0
	return
	end

      function rangen()
	real rangen !compatible with nexus
	rangen=.5d0
	return
      end

c-------------------------------------------------------------------
      subroutine utword(line,i,j,iqu)
c-------------------------------------------------------------------
c  finds the first word of the character string line(j+1:160).
c  the word is line(i:j) (with new i and j).
c  if j<0 or if no word found --> new line read.
c  a text between quotes "..." is considered one word; 
c  stronger: a text between double quotes ""..."" is consid one word
c  stronger: a text between "{ and }" is considered one word
c-------------------------------------------------------------------
c  input: 
c    line: character string (*160)
c    i: integer between 1 and 160
c    iqu: for iqu=1 a "?" is written to output before reading a line,
c         otherwise (iqu/=1) nothing is typed
c  output: 
c    i,j: left and right end of word (word=line(i:j))
c-------------------------------------------------------------------
      include 'epos.inc'
	integer i,j,iqu
	integer mempty
      parameter(mempty=6)
      integer empty(mempty)
      character*1 mk
      character line*160
      character*2 mrk
      data empty/32,44,13,10,0,9/ 
      !space(SP),comma,enter(ET),new line(CR),null,tab(HT)
	integer mxdefine
      parameter(mxdefine=40)
      character w1define*100,w2define*100
	integer ndefine,l1define(mxdefine),l2define(mxdefine)
      common/cdefine/ndefine,l1define,l2define
     &               ,w1define(mxdefine),w2define(mxdefine)
      integer l1,l2,ifopx,k,kmax,ne,ndf,i0,j0


      if(j.ge.0)then
      i=j
      goto1
      endif

    5 continue
      if(iqu.eq.1.and.iprmpt.gt.0)write(ifmt,'(a)')'?'
      if(nopen.eq.0)ifopx=ifop
      if(nopen.gt.0)ifopx=20+nopen
      if(nopen.lt.0)ifopx=ifcp
      read(ifopx,'(a160)',end=9999)line
      if(iecho.eq.1.or.(nopen.ge.0.and.kcpopen.eq.1))then
       kmax=2
       do k=3,160
       if(line(k:k).ne.' ')kmax=k
       enddo
      endif
      if(nopen.ge.0.and.kcpopen.eq.1)
     &  write(ifcp,'(a)')line(1:kmax)
      if(iecho.eq.1)
     &  write(ifmt,'(a)')line(1:kmax)
      i=0

    1 i=i+1
      if(i.gt.160.or.line(i:i).eq.'!')goto5
      do ne=1,mempty
      if(ichar(line(i:i)).eq.empty(ne))goto1
      enddo

      mrk='  '
      mk=' '
      if(line(i:i).eq.'~')mk='~'
      if(line(i:i+1).eq.'"{')mrk='}"'
      if(line(i:i+1).eq.'""')mrk='""'
      if(mrk.ne.'  ')goto10
      if(line(i:i).eq.'"')mk='"'
      if(mk.ne.' ')goto8
      j=i-1
    6 j=j+1
      if(j.gt.160)goto7
      if(line(j:j).eq.'!')goto7
      do ne=1,mempty
      if(ichar(line(j:j)).eq.empty(ne))goto7
      enddo
      goto6

    8 continue
      if(i.ge.160-1)stop'utword: make line shorter!!!         '
      i=i+1
      j=i
      if(line(j:j).eq.mk)stop'utword: empty string!!!           '
    9 j=j+1
      if(j.gt.160)goto7
      if(line(j:j).eq.mk)then
      line(i-1:i-1)=' '
      line(j:j)=' '
      goto7
      endif
      goto9

   10 continue
      if(i.ge.160-3)stop'utword: make line shorter!!!!          '
      i=i+2
      j=i
      if(line(j:j+1).eq.mrk)stop'utword: empty string!!!!        '
   11 j=j+1
      if(j+1.gt.160)goto7
      if(line(j:j+1).eq.mrk)then
      line(i-2:i-1)='  '
      line(j:j+1)='  '
      goto7
      endif
      goto11

    7 j=j-1
      !--------#define---------------
      if(ndefine.gt.0)then
        do ndf=1,ndefine
          l1=l1define(ndf)
          l2=l2define(ndf)
          do i0=i,j+1-l1
            if(line(i0:i0-1+l1).eq.w1define(ndf)(1:l1))then
              if(l2.eq.l1)then
                line(i0:i0-1+l1)=w2define(ndf)(1:l2)
              elseif(l2.lt.l1)then 
                line(i0:i0+l2-1)=w2define(ndf)(1:l2)
                do k=i0+l2,i0-1+l1
                  line(k:k)=' '
                enddo
              elseif(l2.gt.l1)then 
                do k=i0+l1,i0+l2-1
                  if(line(k:k).ne.' ')
     &        stop'utword: no space for `define` replacement.   '
                enddo
                line(i0:i0+l2-1)=w2define(ndf)(1:l2)
                j=i0+l2-1
              endif 
            endif
          enddo
        enddo
       do k=i,j
         if(line(k:k).ne.' ')j0=j
       enddo
       j=j0
      endif
      !--------
      return

9999  close(ifopx)
      nopen=nopen-1
      if(nopen.eq.0.and.iprmpt.eq.-1)iprmpt=1
      goto5
      end

c--------------------------------------------------------------------
      subroutine utworn(line,j,ne)
c--------------------------------------------------------------------
c  returns number ne of nonempty characters of line(j+1:160)
c--------------------------------------------------------------------
      implicit none
      character line*160
	integer j,ne,l
      ne=0
      do l=j+1,160
      if(line(l:l).ne.' ')ne=ne+1
      enddo
      return
      end


